/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <windows.h>
#include "config.h"

#include "nSX2.h"
#include "GUI_PluginsDialog.h"
#include "Translation.h"
#include "GUI_SettingsSheets.h"

#define CfgFileName "nSX2.cfg"

static char CfgFile[_MAX_PATH];

void InitCfgFileName(void) {
	char path_buffer[_MAX_PATH], drive[_MAX_DRIVE] ,dir[_MAX_DIR];
	char fname[_MAX_FNAME],ext[_MAX_EXT];
	
	GetModuleFileName(NULL,path_buffer,sizeof(path_buffer));
	_splitpath( path_buffer, drive, dir, fname, ext );
	sprintf(CfgFile,"%s%s%s",drive,dir,CfgFileName);
	
} 


void WriteCfgString(char *Section,char *Key,char *Value) {
    WritePrivateProfileString(Section,Key,Value,CfgFile);         
    
}


void ReadCfgString(char *Section,char *Key,char *DefaultValue,char *retValue) {
    GetPrivateProfileString( Section, Key, DefaultValue, retValue, 800, CfgFile);
    
}

int ReadCfgInt(char *Section,char *Key,int DefaultValue) {
    int ret;
    ret = GetPrivateProfileInt(Section, Key, DefaultValue, CfgFile);
    return ret;
    
}


int nSX2LoadConfig ( void ) {
    InitCfgFileName();
            
    LoadDefaultPlugins();
    
    loadSettings();
    
    return TRUE;
}
