/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <windows.h>
#include <commctrl.h>	


#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "nSX2.h"
#include "PS2Edefs.h"

#include "pluggins_main.h"

#include "_Debuger/debuger.h"

#include "sif.h"

#include "GUI_MainWindowCallbacks.h"
#include "GUI_PluginsDialog.h"
#include "resource.h"


extern HANDLE hThread; 

/* Config Load Elf File */
_u8		LoadElfFile;

/********************************************************************************/
/*	MENU : FILE 																*/
/*	ITEM : LOAD ELF																*/
/********************************************************************************/
void GUI_LoadElf( HWND hwnd ) {

    OPENFILENAME ofn;

    char szFileName[MAX_PATH] = "";

    ZeroMemory(&ofn, sizeof(ofn));

    ofn.lStructSize = sizeof(ofn); // SEE NOTE BELOW
    ofn.hwndOwner = hwnd;
    ofn.lpstrFilter = "Elf Files (*.elf)\0*.elf\0All Files (*.*)\0*.*\0";
    ofn.lpstrFile = szFileName;
    ofn.nMaxFile = MAX_PATH;
    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "elf";
	ofn.lpstrInitialDir = nSX2DemoDir;
    if(GetOpenFileName(&ofn))
    {
        // Do something usefull with the filename stored in szFileName 
        strcpy(ElfToExecute, szFileName);
		
		LoadElfFile = LOAD_ELF_FILE;
        Init_Emulation_Interp ( hwnd );
    }


}

/********************************************************************************/
/*	MENU : FILE 																*/
/*	ITEM : LOAD ISO																*/
/********************************************************************************/

void GUI_LoadISO( HWND hwnd ) {	

	LoadElfFile = LOAD_CDVD;	
	Init_Emulation_Interp ( hwnd );
}


void GUI_LoadBIOS( HWND hwnd ) {	

	LoadElfFile = LOAD_BIOS;	
	Init_Emulation_Interp ( hwnd );
}



/********************************************************************************/
/*	MENU : EMULATION 															*/
/*	ITEM : GO																	*/
/********************************************************************************/

void 	GUI_EmulationRUN	( HWND hwnd ) 	{	MipsCpu.halt = 0;	}

void	GUI_EmulationPAUSE	( HWND hwnd )	{	MipsCpu.halt = 1;	}

/********************************************************************************/
/*	MENU : DEBUGER 																*/
/*	ITEM : START																*/
/********************************************************************************/


void GUI_ViewDebuger( HWND hwnd ) {	(* DBG_ShowHideDebuger) ( hwnd );	}

void GUI_LoadNothing( HWND hwnd ) {	

	LoadElfFile = LOAD_NOTHING;	
	Init_Emulation_Interp ( hwnd );


}

/********************************************************************************/
/*	MENU : PLUGINS 																*/
/*	ITEM : PLUGINS															*/
/********************************************************************************/


void GUI_SettingPlugins( HWND hwnd ) { OpenPluginsDialog( hwnd); }


/************************************************************************************/

void	GUI_SendStopMainLoop	( void ) 		{	SetInterpreterRunning ( FALSE ) ;  	}
void	SetInterpreterRunning	( int fState ) 	{	MipsCpu.InterpRunning = fState;		}

int		GetInterpreterRunning	( void ) 		{
	int returnValue;

	returnValue = MipsCpu.InterpRunning ;

	return returnValue;

}

void	GUI_SetStatusBar_BOX0( char * fTitle ) {

	    SendMessage(hStatus, SB_SETTEXT, 0, (LPARAM)fTitle);

}










