/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef	LINKED_LIST_H
#define	LINKED_LIST_H

#define	LL_WITH_FREE	0
#define	LL_NO_FREE		1





char * 		LLThread_PrintList	( char * fTitle, LLThread * fList );

void		LLThread_Init		( LLThread * fList );
void		LLThread_Free		( LLThread  ** fList );

LLThread*	LLThread_CreateItem ( PS2_Thread * fData );


void		LLThread_AddEnd		( LLThread ** fList, LLThread * fItem );
void		LLThread_AddFirst 	( LLThread ** fList, LLThread * fItem );

LLThread*	LLThread_RemoveFirst( LLThread ** fList, _u8 fDestroy );
LLThread*	LLThread_RemoveEnd 	( LLThread ** fList, _u8 fDestroy ) ;
LLThread*	LLThread_Remove 	( LLThread ** fList, LLThread * fItem , _u8 fDestroy);

LLThread* 	LLThread_Find 		( LLThread * fList , _u32 fID );





















#endif
