/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include "nSX2_type.h"

#ifndef _VIF_H
#define _VIF_H


/* Define or Undefine if you want VIF LOG */
/* REGISTERS */
#define	VIF_LOG	VIF_Log
//#undef	VIF_Log

/* VIF STATUS */
#define	VIF_LOG_L2	VIF_Log
//#undef	VIF_LOG_L2

/* VIF TRANSFERT */
#define	VIF_LOG_TR	VIF_Log
//#undef	VIF_LOG_TR



#define		VIF0	0
#define		VIF1	1



/********************************************************************************/
/*						VIF0 DEFINES											*/
/********************************************************************************/


#define 	VIF0_STAT_REG 		0x10003800	//Status
#define 	VIF0_FBRST_REG		0x10003810	//Operation control
#define 	VIF0_ERR_REG		0x10003820	//Error status
#define 	VIF0_MARK_REG		0x10003830	//Mark value
#define 	VIF0_CYCLE_REG		0x10003840	//Data write cycle
#define 	VIF0_MODE_REG		0x10003850	//ADD mode
#define 	VIF0_NUM_REG		0x10003860	//Amount of non-transferred data
#define 	VIF0_MASK_REG		0x10003870	//Write mask pattern
#define 	VIF0_CODE_REG		0x10003880	//Last processed VIFcode
#define 	VIF0_ITOPS_REG		0x10003890	//Next ITOP value
#define 	VIF0_ITOP_REG		0x100038d0	//ITOP value
#define 	VIF0_R0_REG			0x10003900	//Filling data R0 (Row register)
#define 	VIF0_R1_REG			0x10003910	//Filling data R1 (Row register)
#define 	VIF0_R2_REG			0x10003920	//Filling data R2 (Row register)
#define 	VIF0_R3_REG			0x10003930	//Filling data R3 (Row register)
#define 	VIF0_C0_REG			0x10003940	//Filling data C0 (Col register)
#define 	VIF0_C1_REG			0x10003950	//Filling data C1 (Col register)
#define 	VIF0_C2_REG			0x10003960	//Filling data C2 (Col register)
#define 	VIF0_C3_REG			0x10003970	//Filling data C3 (Col register)



/********************************************************************************/
/*						VIF1 DEFINES											*/
/********************************************************************************/


#define 	VIF1_STAT_REG 		0x10003c00  //Status
#define 	VIF1_FBRST_REG		0x10003c10	//Operation Control
#define 	VIF1_ERR_REG		0x10003c20	//Error status
#define 	VIF1_MARK_REG		0x10003c30	//Mark Value
#define 	VIF1_CYCLE_REG		0x10003c40	//Data write cycle
#define		VIF1_MODE_REG		0x10003c50	//ADD mode
#define 	VIF1_NUM_REG		0x10003c60	//Amount of non-transferred data
#define 	VIF1_MASK_REG		0x10003c70	//Write mask pattern
#define 	VIF1_CODE_REG		0x10003c80	//Last processed VIFcode
#define 	VIF1_ITOPS_REG		0x10003c90	//Next ITOP value
#define 	VIF1_BASE_REG		0x10003ca0	//Base address of double buffer
#define 	VIF1_OFST_REG		0x10003cb0	//Offset of double buffer
#define 	VIF1_TOPS_REG		0x10003cc0	//Next TOP value/data write address
#define 	VIF1_ITOP_REG		0x10003cd0	//ITOP value
#define 	VIF1_TOP_REG		0x10003ce0	//TOP value
#define 	VIF1_R0				0x10003d00	//Filling data R0 (Row register)
#define 	VIF1_R1				0x10003d10	//Filling data R1 (Row register)
#define 	VIF1_R2				0x10003d20	//Filling data R2 (Row register)
#define 	VIF1_R3				0x10003d30	//Filling data R3 (Row register)
#define 	VIF1_C0				0x10003d40	//Filling data C0 (Col register)
#define 	VIF1_C1				0x10003d50	//Filling data C1 (Col register)
#define 	VIF1_C2				0x10003d60	//Filling data C2 (Col register)
#define 	VIF1_C3				0x10003d70	//Filling data C3 (Col register)



/********************************************************************************/
/*						VIF TAG COMMAND											*/
/********************************************************************************/

#define VIF_CMD_NOP			0x00
#define VIF_CMD_STCYCL		0x01
#define VIF_CMD_OFFSET		0x02
#define VIF_CMD_BASE		0x03
#define VIF_CMD_ITOP		0x04
#define VIF_CMD_STMOD		0x05
#define VIF_CMD_MSKPATH3	0x06
#define VIF_CMD_MARK		0x07

#define VIF_CMD_FLUSHE		0x10
#define VIF_CMD_FLUSH		0x11
#define VIF_CMD_FLUSHA		0x13

#define VIF_CMD_MSCAL		0x14
#define VIF_CMD_MSCALF		0x15
#define VIF_CMD_MSCNT		0x17


#define VIF_CMD_STMASK		0x20
#define VIF_CMD_STROW		0x30
#define VIF_CMD_STCOL		0x31

#define VIF_CMD_MPG			0x4A
#define VIF_CMD_DIRECT		0x50
#define VIF_CMD_DIRECTHL	0x51

#define VIF_CMD_UNPACK_S32		0x60	
#define VIF_CMD_UNPACK_S32_M	0x70
#define VIF_CMD_UNPACK_S16		0x61
#define VIF_CMD_UNPACK_S16_M	0x71
#define VIF_CMD_UNPACK_S8		0x62
#define VIF_CMD_UNPACK_S8_M		0x72
#define VIF_CMD_UNPACK_V2_32	0x64
#define VIF_CMD_UNPACK_V2_32_M	0x74
#define VIF_CMD_UNPACK_V2_16	0x65
#define VIF_CMD_UNPACK_V2_16_M  0x75
#define VIF_CMD_UNPACK_V2_8		0x66
#define VIF_CMD_UNPACK_V2_8_M	0x76
#define VIF_CMD_UNPACK_V3_32	0x68
#define VIF_CMD_UNPACK_V3_32_M	0x78
#define VIF_CMD_UNPACK_V3_16	0x69
#define VIF_CMD_UNPACK_V3_16_M	0x79
#define VIF_CMD_UNPACK_V3_8		0x6A
#define VIF_CMD_UNPACK_V3_8_M	0x7A
#define VIF_CMD_UNPACK_V4_32	0x6C
#define VIF_CMD_UNPACK_V4_32_M	0x7C
#define VIF_CMD_UNPACK_V4_16	0x6D
#define VIF_CMD_UNPACK_V4_16_M	0x7D
#define VIF_CMD_UNPACK_V4_8		0x6E
#define VIF_CMD_UNPACK_V4_8_M	0x7E
#define VIF_CMD_UNPACK_V4_5		0x6F
#define VIF_CMD_UNPACK_V4_5_M	0x7F



typedef struct _VIFRegisters {
	_u32	stat;			// 0x00  -  Status
	_u32	null0[3];		// 0x04 0x08 0x0C
	_u32	fbrst;			// 0x10  -  Operation Control
	_u32	null1[3];		// 0x14 0x18 0x1C
	_u32	err;			// 0x20  -  Error status
	_u32	null2[3];		// 0x24 0x28 0x2C
	_u32	mark;			// 0x30  -  Mark Value
	_u32	null3[3];		// 0x34 0x38 0x3C
	_u32	cycle;			// 0x40  -  Data write cycle
	_u32	null4[3];		// 0x44 0x48 0x4C
	_u32	mode;			// 0x50  -  ADD mode
	_u32	null5[3];		// 0x54 0x08 0x0C
	_u32	num;			// 0x60  -  Amount of non-transferred data
	_u32	null6[3];		// 0x64 0x18 0x1C
	_u32	mask;			// 0x70  -  Write mask pattern
	_u32	null7[3];		// 0x74 0x28 0x2C
	_u32	code;			// 0x80  -  Last processed VIFcode
	_u32	null8[3];		// 0x84 0x38 0x3C
	_u32	itops;			// 0x90  -  Next ITOP value
	_u32	null9[3];		// 0x94 0x48 0x4C
	_u32	base;			// 0xa0  -  Base address of double buffer
	_u32	null10[3];		// 0xa4 0x08 0x0C
	_u32	ofst;			// 0xb0  -  Offset of double buffer
	_u32	null11[3];		// 0xb4 0x18 0x1C
	_u32	tops;			// 0xc0  -  Next TOP value/data write address
	_u32	null12[3];		// 0xc4 0x28 0x2C
	_u32	itop;			// 0xd0  -  ITOP value
	_u32	null13[3];		// 0xd4 0x38 0x3C
	_u32	top;			// 0xe0  -  TOP value
	_u32	null14[7];		// 0xe4 0x48 0x4C 0xf0	0xf4 0xf8 0xfC
	_u32	r0;				// 0x00  -  Filling data R0 (Row register)
	_u32	null15[3];		// 0x04 0x08 0x0C
	_u32	r1;				// 0x10  -  Filling data R1 (Row register)
	_u32	null16[3];		// 0x14 0x18 0x1C
	_u32	r2;				// 0x20  -  Filling data R2 (Row register)
	_u32	null17[3];		// 0x24 0x28 0x2C
	_u32	r3;				// 0x30  -  Filling data R3 (Row register)
	_u32	null18[3];		// 0x34 0x38 0x3C
	_u32	c0;				// 0x40  -  Filling data C0 (Col register)
	_u32	null19[3];		// 0x44 0x48 0x4C
	_u32	c1;				// 0x50  -  Filling data C1 (Col register)
	_u32	null20[3];		// 0x54 0x08 0x0C
	_u32	c2;				// 0x60  -  Filling data C2 (Col register)
	_u32	null21[3];		// 0x64 0x18 0x1C
	_u32	c3;				// 0x70  -  Filling data C3 (Col register)
	

} VIFRegisters;

typedef struct _VPUDataDecompresionUnit {

	VIFRegisters	*Reg;

	_u8				iBitInterruptEnable;
	_u8				IgnoreMismatchDmaTAGError;
	_u8				IgnoreVIFCodeError;

} VPUDataDecompresionUnit;


extern VPUDataDecompresionUnit	VIF[2];

/* main */
void 	VIF_Log 	( char * ftext  , ...   );
void	VIF_Init	( void );

/* VIF1 main */
void	VIF1_Read 	( _u64 fPhysicalAddress, _u128 * fVal, 	_u8 fDataType );
void	VIF1_Write 	( _u64 fPhysicalAddress, _u128 fVal,  	_u8 fDataType );

/* VIF0 main */
void	VIF0_Read 	( _u64 fPhysicalAddress, _u128 * fVal, 	_u8 fDataType );
void	VIF0_Write 	( _u64 fPhysicalAddress, _u128 fVal, 	_u8 fDataType );

/* Common */
_u32	VIF_ComputePackLenght 			( _u8 fVIF, _u8 vn, 			_u8 vl, _u16 fsize);
void 	VIF_CopyMicroProgram 			( _u8 fVIF, _u32 * CurrentData, _u32 fsize );
void 	VIF_InitMicroProgramActivation 	( _u8 fVIF ) ;

/* Transfert */
void VIF_Transfer	( _u8 fVIF, _u32 * fAddr, _u32 fsize );

/* Unpack */
void VIF_Unpack_V4_32	( _u8 fVIF, _u32 * CurrentData, _u32 fUnpackDataSize);

#endif






