/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include <math.h>
#include <string.h>


#include "nSX2.h"
#include "PS2Edefs.h"

#include "VU.h"
#include "VU1_micromode_tables.h"
#include "VU1_micromode_debug.h"

/*
Dump the VU microprogram to the output file
Not very Clean
*/
void VIF1_DumpMicroCodetoLogFile( _u32 * fData , _u32 fsize ) {
	char TempText[200];

	/* Dump only once because this func is called more than once ( each
	time the a Microprogram is transfered to the VU ) and for
	 the moment I only want the code be written on file once
	*/
	static _u8	AlreadyDone = 0; // first time 
	/* static means the variable will no be destroyed when the function end 
	 but keep his last value */


	_u32 boucle;
	_u32	LowerOp;
	_u32	UpperOp;




	if ( AlreadyDone == 0 ) {


	/* debug_vu1 = 1;  I REMOVED THIS BECAUSE IT GAVE ME ERRORS */
	VectorUnit1.PC = 0;


	/* for each opcode */
	for ( boucle = 0 ; boucle < ( fsize / 2 )  ; boucle++ ) {


		LowerOp = *( (_u32 *) (( _u8 *)( VectorUnit1.MicroMem + VectorUnit1.PC ) ));
		UpperOp = *( (_u32 *) (( _u8 *)( VectorUnit1.MicroMem + VectorUnit1.PC + 4 ) ));

		VectorUnit1.PC = VectorUnit1.PC + 8;		
		
		/* first upper */ 
		MipsCpu.vuOpcode = UpperOp;
		dCOP2_MI_VU1_UPPER[(MipsCpu.vuOpcode&0x3F) ]();	
		PrintToOutputFile( debugTempTextVU1);


		/* second lower */ 
		MipsCpu.vuOpcode = LowerOp;
		dCOP2_MI_VU1_LOWER[(MipsCpu.vuOpcode >> 25) & 0x7F]();
		PrintToOutputFile( debugTempTextVU1);


	
	}
	AlreadyDone = 1;
	/* debug_vu1 = 0;  I REMOVED THIS BECAUSE IT GAVE ME ERRORS */
	}

}






#include "VIF.h"

