/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include "VU1_micromode.h"
#include "VU1_micromode_debug.h"

static void (*COP2_MI_VU1_UPPER[64])(void) = {

VU1_ADDbc,	VU1_ADDbc,	VU1_ADDbc,	VU1_ADDbc, 	VU1_SUBbc,	VU1_SUBbc,	VU1_SUBbc,	VU1_SUBbc,
VU1_MADDbc,	VU1_MADDbc,	VU1_MADDbc,	VU1_MADDbc, VU1_MSUBbc,	VU1_MSUBbc,	VU1_MSUBbc,	VU1_MSUBbc,

VU1_MAXbc,	VU1_MAXbc,	VU1_MAXbc,	VU1_MAXbc, 	VU1_MINIbc,	VU1_MINIbc,	VU1_MINIbc,	VU1_MINIbc,
VU1_MULbc,	VU1_MULbc,	VU1_MULbc,	VU1_MULbc, 	VU1_MULq, 	VU1_MAXi, 	VU1_MULi, 	VU1_MINIi,

VU1_ADDq, 	VU1_MADDq, 	VU1_ADDi, 	VU1_MADDi, 	VU1_SUBq, 	VU1_MSUBq, 	VU1_SUBi, 	VU1_MSUBi,
VU1_ADD, 	VU1_MADD, 	VU1_MUL, 	VU1_MAX, 	VU1_SUB, 	VU1_MSUB, 	VU1_OPMSUB, VU1_MINI,

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI, 
VU1_COP2_MI_VU1_UPPER_T60, 						VU1_COP2_MI_VU1_UPPER_T61,	
VU1_COP2_MI_VU1_UPPER_T62,						VU1_COP2_MI_VU1_UPPER_T63


};

static char * debug_COP2_MI_VU1_UPPER[64] = {

"VU1_ADDbc",	"VU1_ADDbc",	"VU1_ADDbc",	"VU1_ADDbc", 	"VU1_SUBbc",	"VU1_SUBbc",	"VU1_SUBbc",	"VU1_SUBbc",
"VU1_MADDbc",	"VU1_MADDbc",	"VU1_MADDbc",	"VU1_MADDbc", 	"VU1_MSUBbc",	"VU1_MSUBbc",	"VU1_MSUBbc",	"VU1_MSUBbc",

"VU1_MAXbc",	"VU1_MAXbc",	"VU1_MAXbc",	"VU1_MAXbc", 	"VU1_MINIbc",	"VU1_MINIbc",	"VU1_MINIbc",	"VU1_MINIbc",
"VU1_MULbc",	"VU1_MULbc",	"VU1_MULbc",	"VU1_MULbc", 	"VU1_MULq", 	"VU1_MAXi", 	"VU1_MULi", 	"VU1_MINIi",

"VU1_ADDq", 	"VU1_MADDq", 	"VU1_ADDi", 	"VU1_MADDi", 	"VU1_SUBq", 	"VU1_MSUBq", 	"VU1_SUBi", 	"VU1_MSUBi",
"VU1_ADD", 		"VU1_MADD", 	"VU1_MUL", 		"VU1_MAX", 		"VU1_SUB", 		"VU1_MSUB", 	"VU1_OPMSUB", 	"VU1_MINI",

"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI", 
"VU1_COP2_MI_VU1_UPPER_T60", 						"VU1_COP2_MI_VU1_UPPER_T61",	
"VU1_COP2_MI_VU1_UPPER_T62",						"VU1_COP2_MI_VU1_UPPER_T63"


};




static void (*COP2_MI_VU1_UPPER_T60[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBAbc,	VU1_ITOF0,	VU1_FTOI0, 	VU1_MULAbc,	VU1_MULAq,
VU1_ADDAq, 	VU1_SUBAq, 	VU1_ADDA,		VU1_SUBBA, 		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};

static char * debug_COP2_MI_VU1_UPPER_T60[32] = {
"VU1_ADDAbc",	"VU1_SUBAbc",	"VU1_MADDAbc",	"VU1_MSUBAbc",	"VU1_ITOF0",	"VU1_FTOI0", 	"VU1_MULAbc",	"VU1_MULAq",
"VU1_ADDAq", 	"VU1_SUBAq", 	"VU1_ADDA",		"VU1_SUBBA", 		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI"
};




static void (*COP2_MI_VU1_UPPER_T61[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBbc,	VU1_ITOF4,	VU1_FTOI4,	VU1_MULAbc,	VU1_ABS,
VU1_MADDAq,	VU1_MSUBAq,	VU1_MADDA,		VU1_MSUBA, 	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};

static char * debug_COP2_MI_VU1_UPPER_T61[32] = {
"VU1_ADDAbc",	"VU1_SUBAbc",	"VU1_MADDAbc",	"VU1_MSUBbc",	"VU1_ITOF4",	"VU1_FTOI4",	"VU1_MULAbc",	"VU1_ABS",
"VU1_MADDAq",	"VU1_MSUBAq",	"VU1_MADDA",		"VU1_MSUBA", 	"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI"
};



static void (*COP2_MI_VU1_UPPER_T62[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBAbc,	VU1_ITOF12,	VU1_FTOI12,	VU1_MULAbc,	VU1_MULAi,
VU1_ADDAi,	VU1_SUBAi,	VU1_MULA,		VU1_OPMULA,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};

static char * debug_COP2_MI_VU1_UPPER_T62[32] = {
"VU1_ADDAbc",	"VU1_SUBAbc",	"VU1_MADDAbc",	"VU1_MSUBAbc",	"VU1_ITOF12",	"VU1_FTOI12",	"VU1_MULAbc",	"VU1_MULAi",
"VU1_ADDAi",	"VU1_SUBAi",	"VU1_MULA",		"VU1_OPMULA",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI"
};



static void (*COP2_MI_VU1_UPPER_T63[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBAbc,	VU1_ITOF15,	VU1_FTOI15,	VU1_MULAbc,	VU1_CLIP,
VU1_MADDAi,	VU1_MSUBAi,	VU1_NI,			VU1_NOP,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};

static char * debug_COP2_MI_VU1_UPPER_T63[32] = {
"VU1_ADDAbc",	"VU1_SUBAbc",	"VU1_MADDAbc",	"VU1_MSUBAbc",	"VU1_ITOF15",	"VU1_FTOI15",	"VU1_MULAbc",	"VU1_CLIP",
"VU1_MADDAi",	"VU1_MSUBAi",	"VU1_NI",			"VU1_NOP",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI"
};

static void (*COP2_MI_VU1_LOWER[128])(void) = {

VU1_LQ,		VU1_SQ,		VU1_NI,		VU1_NI,		VU1_ILW,		VU1_ISW,		VU1_NI,			VU1_NI,		
VU1_IADDIU,	VU1_ISUBIU,	VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_FCEQ,	VU1_FCSET,	VU1_FCAND,	VU1_FCOR,	VU1_FSEQ,		VU1_FSSET,		VU1_FSAND,		VU1_FSOR,
VU1_FMEQ,	VU1_NI,		VU1_FMAND,	VU1_FMOR,	VU1_FCGET,		VU1_NI,			VU1_NI,			VU1_NI,
VU1_B,		VU1_BAL,	VU1_NI,		VU1_NI,		VU1_JR,			VU1_JALR,		VU1_NI,			VU1_NI,
VU1_IBEQ,	VU1_IBNE,	VU1_NI,		VU1_NI,		VU1_IBLTZ,		VU1_IBGTZ,		VU1_IBLEZ,		VU1_IBGEZ,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_COP2_MI_VU1_LOWER_T64,VU1_NI,VU1_NI,VU1_NI,	VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI

};


static char * debug_COP2_MI_VU1_LOWER[128] = {

"VU1_LQ",		"VU1_SQ",		"VU1_NI",		"VU1_NI",		"VU1_ILW",			"VU1_ISW",			"VU1_NI",			"VU1_NI",		
"VU1_IADDIU",	"VU1_ISUBIU",	"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_FCEQ",		"VU1_FCSET",	"VU1_FCAND",	"VU1_FCOR",		"VU1_FSEQ",			"VU1_FSSET",		"VU1_FSAND",		"VU1_FSOR",
"VU1_FMEQ",		"VU1_NI",		"VU1_FMAND",	"VU1_FMOR",		"VU1_FCGET",		"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_B",		"VU1_BAL",		"VU1_NI",		"VU1_NI",		"VU1_JR",			"VU1_JALR",			"VU1_NI",			"VU1_NI",
"VU1_IBEQ",		"VU1_IBNE",		"VU1_NI",		"VU1_NI",		"VU1_IBLTZ",		"VU1_IBGTZ",		"VU1_IBLEZ",		"VU1_IBGEZ",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_COP2_MI_VU1_LOWER_T64","VU1_NI","VU1_NI","VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",

};

static void (*COP2_MI_VU1_LOWER_T64[64])(void) = {
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_IADD,	VU1_ISUB,	VU1_IADDI,	VU1_NI,		VU1_IAND,		VU1_IOR,		VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_COP2_MI_VU1_LOWER_T64_60,	VU1_COP2_MI_VU1_LOWER_T64_61,	VU1_COP2_MI_VU1_LOWER_T64_62,	VU1_COP2_MI_VU1_LOWER_T64_63


};

static char * debug_COP2_MI_VU1_LOWER_T64[64] = {
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",			"VU1_NI",			"VU1_NI",			"VU1_NI",
"VU1_IADD",		"VU1_ISUB",		"VU1_IADDI",	"VU1_NI",		"VU1_IAND",			"VU1_IOR",			"VU1_NI",			"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_COP2_MI_VU1_LOWER_T64_60",	"VU1_COP2_MI_VU1_LOWER_T64_61",	"VU1_COP2_MI_VU1_LOWER_T64_62",	"VU1_COP2_MI_VU1_LOWER_T64_63"


};


static void (*COP2_MI_VU1_LOWER_T64_60[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_MOVE,	VU1_LQI,	VU1_DIV,	VU1_MTIR,
VU1_RNEXT,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_MFP,	VU1_XTOP,	VU1_XGKICK,	VU1_ESADD,	VU1_EATANxy,VU1_ESQRT,	VU1_ESIN


};


static char * debug_COP2_MI_VU1_LOWER_T64_60[32] = {

"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",	"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_MOVE",		"VU1_LQI",		"VU1_DIV",	"VU1_MTIR",
"VU1_RNEXT",	"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",	"VU1_NI",
"VU1_NI",		"VU1_MFP",		"VU1_XTOP",		"VU1_XGKICK",	"VU1_ESADD",	"VU1_EATANxy",	"VU1_ESQRT","VU1_ESIN"


};



static void (*COP2_MI_VU1_LOWER_T64_61[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_MR32,	VU1_SQI,	VU1_SQRT,	VU1_MFIR,
VU1_RGET,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_XITOP,	VU1_NI,		VU1_ERSADD,	VU1_EATANxz,VU1_ERSQRT,	VU1_EATAN



};


static char * debug_COP2_MI_VU1_LOWER_T64_61[32] = {

"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_MR32",		"VU1_SQI",		"VU1_SQRT",		"VU1_MFIR",
"VU1_RGET",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_XITOP",	"VU1_NI",		"VU1_ERSADD",	"VU1_EATANxz",	"VU1_ERSQRT",	"VU1_EATAN"



};




static void (*COP2_MI_VU1_LOWER_T64_62[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_LQD,	VU1_RSQRT,	VU1_ILWR,
VU1_RINIT,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_ELENG,	VU1_ESUM,	VU1_ERCPR,	VU1_EEXP

};

static char * debug_COP2_MI_VU1_LOWER_T64_62[32] = {

"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",	"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_LQD",	"VU1_RSQRT",	"VU1_ILWR",
"VU1_RINIT",	"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",	"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_ELENG",	"VU1_ESUM",	"VU1_ERCPR",	"VU1_EEXP"

};


static void (*COP2_MI_VU1_LOWER_T64_63[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_SQD,	VU1_WAITQ,	VU1_ISWR,
VU1_RXOR,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_ERLENG,	VU1_NI,		VU1_WAITP,	VU1_NI


};


static char * debug_COP2_MI_VU1_LOWER_T64_63[32] = {

"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_SQD",		"VU1_WAITQ",	"VU1_ISWR",
"VU1_RXOR",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",
"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_NI",		"VU1_ERLENG",	"VU1_NI",		"VU1_WAITP",	"VU1_NI"


};

// DEBUG

static void (*dCOP2_MI_VU1_UPPER[64])(void) = {

dVU1_ADDbc,	dVU1_ADDbc,	dVU1_ADDbc,	dVU1_ADDbc, 	dVU1_SUBbc,	dVU1_SUBbc,	dVU1_SUBbc,	dVU1_SUBbc,
dVU1_MADDbc,	dVU1_MADDbc,	dVU1_MADDbc,	dVU1_MADDbc, dVU1_MSUBbc,	dVU1_MSUBbc,	dVU1_MSUBbc,	dVU1_MSUBbc,

dVU1_MAXbc,	dVU1_MAXbc,	dVU1_MAXbc,	dVU1_MAXbc, 	dVU1_MINIbc,	dVU1_MINIbc,	dVU1_MINIbc,	dVU1_MINIbc,
dVU1_MULbc,	dVU1_MULbc,	dVU1_MULbc,	dVU1_MULbc, 	dVU1_MULq, 	dVU1_MAXi, 	dVU1_MULi, 	dVU1_MINIi,

dVU1_ADDq, 	dVU1_MADDq, 	dVU1_ADDi, 	dVU1_MADDi, 	dVU1_SUBq, 	dVU1_MSUBq, 	dVU1_SUBi, 	dVU1_MSUBi,
dVU1_ADD, 	dVU1_MADD, 	dVU1_MUL, 	dVU1_MAX, 	dVU1_SUB, 	dVU1_MSUB, 	dVU1_OPMSUB, dVU1_MINI,

dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI, 
dVU1_COP2_MI_VU1_UPPER_T60, 						dVU1_COP2_MI_VU1_UPPER_T61,	
dVU1_COP2_MI_VU1_UPPER_T62,						dVU1_COP2_MI_VU1_UPPER_T63


};



static void (*dCOP2_MI_VU1_UPPER_T60[32])(void) = {
dVU1_ADDAbc,	dVU1_SUBAbc,	dVU1_MADDAbc,	dVU1_MSUBAbc,	dVU1_ITOF0,	dVU1_FTOI0, 	dVU1_MULAbc,	dVU1_MULAq,
dVU1_ADDAq, 	dVU1_SUBAq, 	dVU1_ADDA,		dVU1_SUBBA, 	dVU1_NI,	dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,	dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,	dVU1_NI,		dVU1_NI,		dVU1_NI
};


static void (*dCOP2_MI_VU1_UPPER_T61[32])(void) = {
dVU1_ADDAbc,	dVU1_SUBAbc,	dVU1_MADDAbc,	dVU1_MSUBbc,	dVU1_ITOF4,	dVU1_FTOI4,	dVU1_MULAbc,	dVU1_ABS,
dVU1_MADDAq,	dVU1_MSUBAq,	dVU1_MADDA,		dVU1_MSUBA, 	dVU1_NI,	dVU1_NI,	dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,	dVU1_NI,	dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,	dVU1_NI,	dVU1_NI,		dVU1_NI
};


static void (*dCOP2_MI_VU1_UPPER_T62[32])(void) = {
dVU1_ADDAbc,	dVU1_SUBAbc,	dVU1_MADDAbc,	dVU1_MSUBAbc,	dVU1_ITOF12,	dVU1_FTOI12,	dVU1_MULAbc,	dVU1_MULAi,
dVU1_ADDAi,		dVU1_SUBAi,		dVU1_MULA,		dVU1_OPMULA,	dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI
};


static void (*dCOP2_MI_VU1_UPPER_T63[32])(void) = {
dVU1_ADDAbc,	dVU1_SUBAbc,	dVU1_MADDAbc,	dVU1_MSUBAbc,	dVU1_ITOF15,	dVU1_FTOI15,	dVU1_MULAbc,	dVU1_CLIP,
dVU1_MADDAi,	dVU1_MSUBAi,	dVU1_NI,		dVU1_NOP,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI
};


static void (*dCOP2_MI_VU1_LOWER[128])(void) = {

dVU1_LQ,		dVU1_SQ,		dVU1_NI,		dVU1_NI,		dVU1_ILW,		dVU1_ISW,		dVU1_NI,			dVU1_NI,		
dVU1_IADDIU,	dVU1_ISUBIU,	dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_FCEQ,		dVU1_FCSET,		dVU1_FCAND,		dVU1_FCOR,		dVU1_FSEQ,		dVU1_FSSET,		dVU1_FSAND,		dVU1_FSOR,
dVU1_FMEQ,		dVU1_NI,		dVU1_FMAND,		dVU1_FMOR,		dVU1_FCGET,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_B,			dVU1_BAL,		dVU1_NI,		dVU1_NI,		dVU1_JR,		dVU1_JALR,		dVU1_NI,			dVU1_NI,
dVU1_IBEQ,		dVU1_IBNE,		dVU1_NI,		dVU1_NI,		dVU1_IBLTZ,		dVU1_IBGTZ,		dVU1_IBLEZ,		dVU1_IBGEZ,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_COP2_MI_VU1_LOWER_T64,dVU1_NI,VU1_NI,dVU1_NI,	dVU1_NI,	dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI

};


static void (*dCOP2_MI_VU1_LOWER_T64[64])(void) = {
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,			dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,			dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,			dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,			dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,			dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,			dVU1_NI,			dVU1_NI,			dVU1_NI,
dVU1_IADD,		dVU1_ISUB,		dVU1_IADDI,		dVU1_NI,		dVU1_IAND,			dVU1_IOR,			dVU1_NI,			dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_COP2_MI_VU1_LOWER_T64_60,	dVU1_COP2_MI_VU1_LOWER_T64_61,	dVU1_COP2_MI_VU1_LOWER_T64_62,	dVU1_COP2_MI_VU1_LOWER_T64_63


};


static void (*dCOP2_MI_VU1_LOWER_T64_60[32])(void) = {

dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_MOVE,		dVU1_LQI,		dVU1_DIV,		dVU1_MTIR,
dVU1_RNEXT,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_MFP,		dVU1_XTOP,		dVU1_XGKICK,	dVU1_ESADD,		dVU1_EATANxy,	dVU1_ESQRT,		dVU1_ESIN


};

static void (*dCOP2_MI_VU1_LOWER_T64_61[32])(void) = {

dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_MR32,		dVU1_SQI,		dVU1_SQRT,		dVU1_MFIR,
dVU1_RGET,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_XITOP,		dVU1_NI,		dVU1_ERSADD,	dVU1_EATANxz,	dVU1_ERSQRT,	dVU1_EATAN



};


static void (*dCOP2_MI_VU1_LOWER_T64_62[32])(void) = {

dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_LQD,		dVU1_RSQRT,		dVU1_ILWR,
dVU1_RINIT,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_ELENG,		dVU1_ESUM,		dVU1_ERCPR,		dVU1_EEXP

};

static void (*dCOP2_MI_VU1_LOWER_T64_63[32])(void) = {

dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_SQD,		dVU1_WAITQ,		dVU1_ISWR,
dVU1_RXOR,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,
dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_NI,		dVU1_ERLENG,	dVU1_NI,		dVU1_WAITP,		dVU1_NI


};




