/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

/*
NOTA:

the vu Micro and Macro opcodes are the same
Write only once and I hope I can use it for the Two VU mode
param ( not really one ) is the VU which execute the opcode
*/

#ifndef _R5900_COP2_VU_OPCODE_H
#define _R5900_COP2_VU_OPCODE_H

extern float VectorUnit0_UPDATE_MAC_REG_X ( double val );
extern float VectorUnit0_UPDATE_MAC_REG_Y ( double val );
extern float VectorUnit0_UPDATE_MAC_REG_Z ( double val );
extern float VectorUnit0_UPDATE_MAC_REG_W ( double val );

extern void VectorUnit0_UPDATE_STAT_REG( void );
extern void VectorUnit0_UPDATE_STAT_REG_DI( void );


#define VectorUnit0_FD_X_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FD][0])
#define VectorUnit0_FD_Y_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FD][1])
#define VectorUnit0_FD_Z_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FD][2])
#define VectorUnit0_FD_W_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FD][3])

#define VectorUnit0_FS_X_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FS][0])
#define VectorUnit0_FS_Y_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FS][1])
#define VectorUnit0_FS_Z_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FS][2])
#define VectorUnit0_FS_W_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FS][3])

#define VectorUnit0_FS_X_I	VectorUnit0.CPR[CURRENT_VU_FS][0]
#define VectorUnit0_FS_Y_I	VectorUnit0.CPR[CURRENT_VU_FS][1]
#define VectorUnit0_FS_Z_I	VectorUnit0.CPR[CURRENT_VU_FS][2]
#define VectorUnit0_FS_W_I	VectorUnit0.CPR[CURRENT_VU_FS][3]


#define VectorUnit0_FT_X_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FT][0])
#define VectorUnit0_FT_Y_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FT][1])
#define VectorUnit0_FT_Z_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FT][2])
#define VectorUnit0_FT_W_F	*(VectorUnit0.CPR_p_float[CURRENT_VU_FT][3])

#define VectorUnit0_FT_X_I	VectorUnit0.CPR[CURRENT_VU_FT][0]
#define VectorUnit0_FT_Y_I	VectorUnit0.CPR[CURRENT_VU_FT][1]
#define VectorUnit0_FT_Z_I	VectorUnit0.CPR[CURRENT_VU_FT][2]
#define VectorUnit0_FT_W_I	VectorUnit0.CPR[CURRENT_VU_FT][3]



#define	VectorUnit0_ACC_X_F	*(VectorUnit0.ACC_p_float[0])
#define	VectorUnit0_ACC_Y_F	*(VectorUnit0.ACC_p_float[1])
#define	VectorUnit0_ACC_Z_F	*(VectorUnit0.ACC_p_float[2])
#define	VectorUnit0_ACC_W_F	*(VectorUnit0.ACC_p_float[3])

#define VectorUnit0_FT_BC_F *(VectorUnit0.CPR_p_float[CURRENT_VU_FT][CURRENT_VU_BC])
#define VectorUnit0_FT_FTF_F *(VectorUnit0.CPR_p_float[CURRENT_VU_FT][CURRENT_VU_FTF])
#define VectorUnit0_FS_FSF_F *(VectorUnit0.CPR_p_float[CURRENT_VU_FS][CURRENT_VU_FSF])

#define VectorUnit0_Q_F 	*(VectorUnit0.CCR_p_float[ VU_Q_REGISTER ])
#define VectorUnit0_I_F 	*(VectorUnit0.CCR_p_float[ VU_I_REGISTER ])

#define VectorUnit0_CLIP_I	VectorUnit0.CCR[VU_CLIPPIN_FLAG]

#define VectorUnit0_IT_I 	VectorUnit0.CCR[ CURRENT_VU_IT ]
#define VectorUnit0_IS_I 	VectorUnit0.CCR[ CURRENT_VU_IS ]
#define VectorUnit0_ID_I 	VectorUnit0.CCR[ CURRENT_VU_ID ]



extern float VectorUnit1_UPDATE_MAC_REG_X ( double val );
extern float VectorUnit1_UPDATE_MAC_REG_Y ( double val );
extern float VectorUnit1_UPDATE_MAC_REG_Z ( double val );
extern float VectorUnit1_UPDATE_MAC_REG_W ( double val );

extern void VectorUnit1_UPDATE_STAT_REG( void );
extern void VectorUnit1_UPDATE_STAT_REG_DI( void );


#define VectorUnit1_FD_X_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FD][0])
#define VectorUnit1_FD_Y_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FD][1])
#define VectorUnit1_FD_Z_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FD][2])
#define VectorUnit1_FD_W_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FD][3])

#define VectorUnit1_FS_X_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FS][0])
#define VectorUnit1_FS_Y_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FS][1])
#define VectorUnit1_FS_Z_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FS][2])
#define VectorUnit1_FS_W_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FS][3])

#define VectorUnit1_FS_X_I	VectorUnit1.CPR[CURRENT_VU_FS][0]
#define VectorUnit1_FS_Y_I	VectorUnit1.CPR[CURRENT_VU_FS][1]
#define VectorUnit1_FS_Z_I	VectorUnit1.CPR[CURRENT_VU_FS][2]
#define VectorUnit1_FS_W_I	VectorUnit1.CPR[CURRENT_VU_FS][3]


#define VectorUnit1_FT_X_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FT][0])
#define VectorUnit1_FT_Y_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FT][1])
#define VectorUnit1_FT_Z_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FT][2])
#define VectorUnit1_FT_W_F	*(VectorUnit1.CPR_p_float[CURRENT_VU_FT][3])

#define VectorUnit1_FT_X_I	VectorUnit1.CPR[CURRENT_VU_FT][0]
#define VectorUnit1_FT_Y_I	VectorUnit1.CPR[CURRENT_VU_FT][1]
#define VectorUnit1_FT_Z_I	VectorUnit1.CPR[CURRENT_VU_FT][2]
#define VectorUnit1_FT_W_I	VectorUnit1.CPR[CURRENT_VU_FT][3]



#define	VectorUnit1_ACC_X_F	*(VectorUnit1.ACC_p_float[0])
#define	VectorUnit1_ACC_Y_F	*(VectorUnit1.ACC_p_float[1])
#define	VectorUnit1_ACC_Z_F	*(VectorUnit1.ACC_p_float[2])
#define	VectorUnit1_ACC_W_F	*(VectorUnit1.ACC_p_float[3])

#define VectorUnit1_FT_BC_F *(VectorUnit1.CPR_p_float[CURRENT_VU_FT][CURRENT_VU_BC])
#define VectorUnit1_FT_FTF_F *(VectorUnit1.CPR_p_float[CURRENT_VU_FT][CURRENT_VU_FTF])
#define VectorUnit1_FS_FSF_F *(VectorUnit1.CPR_p_float[CURRENT_VU_FS][CURRENT_VU_FSF])

#define VectorUnit1_Q_F 	*(VectorUnit1.CCR_p_float[ VU_Q_REGISTER ])
#define VectorUnit1_I_F 	*(VectorUnit1.CCR_p_float[ VU_I_REGISTER ])
#define VectorUnit1_CLIP_I	VectorUnit1.CCR[VU_CLIPPIN_FLAG]

#define VectorUnit1_IT_I 	VectorUnit1.CCR[ CURRENT_VU_IT ]
#define VectorUnit1_IS_I 	VectorUnit1.CCR[ CURRENT_VU_IS ]
#define VectorUnit1_ID_I 	VectorUnit1.CCR[ CURRENT_VU_ID ]

#define	DEST_X				CURRENT_VU_DEST  & 0x8
#define	DEST_Y				CURRENT_VU_DEST  & 0x4
#define	DEST_Z				CURRENT_VU_DEST  & 0x2
#define	DEST_W				CURRENT_VU_DEST  & 0x1

#define VU_FLOAT_TO_INTEGER_0(val) (_s32)((float)(val))
#define VU_FLOAT_TO_INTEGER_4(val) (_s32)((double)val / 0.0625f)


#define VU_INTEGER_TO_FLOAT_0(val) (float)((_s32)(val)) 

#define	MAC_Reset( VectorUnit ) VectorUnit.CCR[VU_MAC_FLAG] = VectorUnit.CCR[VU_MAC_FLAG] & (~0xFFFF)



/******************************************************************************/
/*	UPPER INSTRUCTIONS														  */	
/******************************************************************************/

#define vuABS(VectorUnit) { \
if ( DEST_X ) VectorUnit##_FT_X_F = (float)fabs(VectorUnit##_FS_X_F) ; \
if ( DEST_Y ) VectorUnit##_FT_Y_F = (float)fabs(VectorUnit##_FS_Y_F) ; \
if ( DEST_Z ) VectorUnit##_FT_Z_F = (float)fabs(VectorUnit##_FS_Z_F) ; \
if ( DEST_W ) VectorUnit##_FT_W_F = (float)fabs(VectorUnit##_FS_W_F) ; \
}

#define vuADD(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_FT_X_F ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_FT_Y_F ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_FT_Z_F ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_FT_W_F ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuADDi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_I_F )); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_I_F )); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_I_F )); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_I_F )); \
VectorUnit##_UPDATE_STAT_REG(); \
}



#define vuADDq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_Q_F )); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_Q_F )); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_Q_F )); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_Q_F )); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuADDbc(VectorUnit) {  \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_FT_BC_F )); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_FT_BC_F )); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_FT_BC_F )); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_FT_BC_F )); \
VectorUnit##_UPDATE_STAT_REG(); \
} 

#define vuADDA(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_FT_X_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_FT_Y_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_FT_Z_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_FT_W_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuADDAi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_I_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_I_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_I_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_I_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuADDAq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_Q_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_Q_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_Q_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_Q_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuADDAbc(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F + VectorUnit##_FT_BC_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F + VectorUnit##_FT_BC_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F + VectorUnit##_FT_BC_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F + VectorUnit##_FT_BC_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuFTOI0(VectorUnit){ \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FT_X_I = VU_FLOAT_TO_INTEGER_0( VectorUnit##_FS_X_F ) ; \
if ( DEST_Y ) VectorUnit##_FT_Y_I = VU_FLOAT_TO_INTEGER_0( VectorUnit##_FS_Y_F ) ; \
if ( DEST_Z ) VectorUnit##_FT_Z_I = VU_FLOAT_TO_INTEGER_0( VectorUnit##_FS_Z_F ) ; \
if ( DEST_W ) VectorUnit##_FT_W_I = VU_FLOAT_TO_INTEGER_0( VectorUnit##_FS_W_F ) ; \
}

#define vuFTOI4(VectorUnit){ \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FT_X_I = VU_FLOAT_TO_INTEGER_4( VectorUnit##_FS_X_F ) ; \
if ( DEST_Y ) VectorUnit##_FT_Y_I = VU_FLOAT_TO_INTEGER_4( VectorUnit##_FS_Y_F ) ; \
if ( DEST_Z ) VectorUnit##_FT_Z_I = VU_FLOAT_TO_INTEGER_4( VectorUnit##_FS_Z_F ) ; \
if ( DEST_W ) VectorUnit##_FT_W_I = VU_FLOAT_TO_INTEGER_4( VectorUnit##_FS_W_F ) ; \
}

#define vuITOF0(VectorUnit){ \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FT_X_F = VU_INTEGER_TO_FLOAT_0( VectorUnit##_FS_X_I ) ; \
if ( DEST_Y ) VectorUnit##_FT_Y_F = VU_INTEGER_TO_FLOAT_0( VectorUnit##_FS_Y_I ) ; \
if ( DEST_Z ) VectorUnit##_FT_Z_F = VU_INTEGER_TO_FLOAT_0( VectorUnit##_FS_Z_I ) ; \
if ( DEST_W ) VectorUnit##_FT_W_F = VU_INTEGER_TO_FLOAT_0( VectorUnit##_FS_W_I ) ; \
}

#define vuMADD(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_FT_X_F ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_FT_Y_F ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_FT_Z_F ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_FT_W_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuMADDi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_I_F ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_I_F ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_I_F ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_I_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMADDq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_Q_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}



#define vuMADDbc(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_FT_BC_F ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_FT_BC_F ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_FT_BC_F ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_FT_BC_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMADDA(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_FT_X_F ) ) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_FT_Y_F ) ) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_FT_Z_F ) ) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_FT_W_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMADDAi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_I_F ) ) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_I_F ) ) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_I_F ) ) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_I_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMADDAq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_Q_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}



#define vuMADDAbc(VectorUnit) {  \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F + ( VectorUnit##_FS_X_F * VectorUnit##_FT_BC_F))); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F + ( VectorUnit##_FS_Y_F * VectorUnit##_FT_BC_F))); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F + ( VectorUnit##_FS_Z_F * VectorUnit##_FT_BC_F))); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F + ( VectorUnit##_FS_W_F * VectorUnit##_FT_BC_F))); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuMAX(VectorUnit) { \
if ( DEST_X ) { \
	if ( VectorUnit##_FS_X_F > VectorUnit##_FT_X_F ) {\
		VectorUnit##_FD_X_F = VectorUnit##_FS_X_F ;\
	} else {\
		VectorUnit##_FD_X_F = VectorUnit##_FT_X_F ;\
	}\
}\
if ( DEST_Y ) { \
	if ( VectorUnit##_FS_Y_F > VectorUnit##_FT_Y_F ) {\
		VectorUnit##_FD_Y_F = VectorUnit##_FS_Y_F ;\
	} else {\
		VectorUnit##_FD_Y_F = VectorUnit##_FT_Y_F ;\
	}\
}\
if ( DEST_Z ) { \
	if ( VectorUnit##_FS_Z_F > VectorUnit##_FT_Z_F ) {\
		VectorUnit##_FD_Z_F = VectorUnit##_FS_Z_F ;\
	} else {\
		VectorUnit##_FD_Z_F = VectorUnit##_FT_Z_F ;\
	}\
}\
if ( DEST_W ) { \
	if ( VectorUnit##_FS_W_F > VectorUnit##_FT_W_F ) {\
		VectorUnit##_FD_W_F = VectorUnit##_FS_W_F ;\
	} else {\
		VectorUnit##_FD_W_F = VectorUnit##_FT_W_F ;\
	}\
}\
}

#define vuMAXi(VectorUnit) { \
if ( DEST_X ) { \
	if ( VectorUnit##_FS_X_F > VectorUnit##_I_F ) {\
		VectorUnit##_FD_X_F = VectorUnit##_FS_X_F ;\
	} else {\
		VectorUnit##_FD_X_F = VectorUnit##_I_F ;\
	}\
}\
if ( DEST_Y ) { \
	if ( VectorUnit##_FS_Y_F > VectorUnit##_I_F ) {\
		VectorUnit##_FD_Y_F = VectorUnit##_FS_Y_F ;\
	} else {\
		VectorUnit##_FD_Y_F = VectorUnit##_I_F ;\
	}\
}\
if ( DEST_Z ) { \
	if ( VectorUnit##_FS_Z_F > VectorUnit##_I_F ) {\
		VectorUnit##_FD_Z_F = VectorUnit##_FS_Z_F ;\
	} else {\
		VectorUnit##_FD_Z_F = VectorUnit##_I_F ;\
	}\
}\
if ( DEST_W ) { \
	if ( VectorUnit##_FS_W_F > VectorUnit##_I_F ) {\
		VectorUnit##_FD_W_F = VectorUnit##_FS_W_F ;\
	} else {\
		VectorUnit##_FD_W_F = VectorUnit##_I_F ;\
	}\
}\
}



#define vuMAXbc(VectorUnit) { \
if ( DEST_X ) { \
	if (  VectorUnit##_FS_X_F > VectorUnit##_FT_BC_F ) {\
		VectorUnit##_FD_X_F = VectorUnit##_FS_X_F ;\
	} else {\
			VectorUnit##_FD_X_F = VectorUnit##_FT_BC_F ;\
	}\
}\
if ( DEST_Y ) { \
	if (  VectorUnit##_FS_Y_F > VectorUnit##_FT_BC_F ) {\
			VectorUnit##_FD_Y_F = VectorUnit##_FS_Y_F ;\
	} else {\
		VectorUnit##_FD_Y_F = VectorUnit##_FT_BC_F ;\
	}\
}\
if ( DEST_Z ) { \
	if (  VectorUnit##_FS_Z_F > VectorUnit##_FT_BC_F ) {\
		VectorUnit##_FD_Z_F = VectorUnit##_FS_Z_F ;\
	} else {\
		VectorUnit##_FD_Z_F = VectorUnit##_FT_BC_F ;\
	}\
}\
if ( DEST_W ) { \
	if (  VectorUnit##_FS_W_F > VectorUnit##_FT_BC_F ) {\
		VectorUnit##_FD_W_F = VectorUnit##_FS_W_F ;\
	} else {\
		VectorUnit##_FD_W_F = VectorUnit##_FT_BC_F ;\
	}\
}\
}


#define vuMINIi(VectorUnit) { \
if ( DEST_X ) { \
	if ( VectorUnit##_FS_X_F < *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) {\
		VectorUnit##_FD_X_F = VectorUnit##_FS_X_F ;\
	} else {\
		VectorUnit##_FD_X_F = *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ;\
	}\
}\
if ( DEST_Y ) { \
	if ( VectorUnit##_FS_Y_F < *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) {\
		VectorUnit##_FD_Y_F = VectorUnit##_FS_Y_F ;\
	} else {\
		VectorUnit##_FD_Y_F = *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ;\
	}\
}\
if ( DEST_Z ) { \
	if ( VectorUnit##_FS_Z_F < *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) {\
		VectorUnit##_FD_Z_F = VectorUnit##_FS_Z_F ;\
	} else {\
		VectorUnit##_FD_Z_F = *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ;\
	}\
}\
if ( DEST_W ) { \
	if ( VectorUnit##_FS_W_F < *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) {\
		VectorUnit##_FD_W_F = VectorUnit##_FS_W_F ;\
	} else {\
		VectorUnit##_FD_W_F = *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ;\
	}\
}\
}

#define vuMINI(VectorUnit) { \
if ( DEST_X ) { \
	if ( VectorUnit##_FS_X_F < VectorUnit##_FT_X_F ) {\
		VectorUnit##_FD_X_F = VectorUnit##_FS_X_F ;\
	} else {\
		VectorUnit##_FD_X_F = VectorUnit##_FT_X_F ;\
	}\
}\
if ( DEST_Y ) { \
	if ( VectorUnit##_FS_Y_F < VectorUnit##_FT_Y_F ) {\
		VectorUnit##_FD_Y_F = VectorUnit##_FS_Y_F ;\
	} else {\
		VectorUnit##_FD_Y_F = VectorUnit##_FT_Y_F ;\
	}\
}\
if ( DEST_Z ) { \
	if ( VectorUnit##_FS_Z_F < VectorUnit##_FT_Z_F ) {\
		VectorUnit##_FD_Z_F = VectorUnit##_FS_Z_F ;\
	} else {\
		VectorUnit##_FD_Z_F = VectorUnit##_FT_Z_F ;\
	}\
}\
if ( DEST_W ) { \
	if ( VectorUnit##_FS_W_F < VectorUnit##_FT_W_F ) {\
		VectorUnit##_FD_W_F = VectorUnit##_FS_W_F ;\
	} else {\
		VectorUnit##_FD_W_F = VectorUnit##_FT_W_F ;\
	}\
}\
}

#define vuMINIbc(VectorUnit) { \
if ( DEST_X ) { \
	if (  VectorUnit##_FS_X_F < VectorUnit##_FT_BC_F ) {\
		VectorUnit##_FD_X_F = VectorUnit##_FS_X_F ;\
	} else {\
			VectorUnit##_FD_X_F = VectorUnit##_FT_BC_F ;\
	}\
}\
if ( DEST_Y ) { \
	if (  VectorUnit##_FS_Y_F < VectorUnit##_FT_BC_F ) {\
			VectorUnit##_FD_Y_F = VectorUnit##_FS_Y_F ;\
	} else {\
		VectorUnit##_FD_Y_F = VectorUnit##_FT_BC_F ;\
	}\
}\
if ( DEST_Z ) { \
	if (  VectorUnit##_FS_Z_F < VectorUnit##_FT_BC_F ) {\
		VectorUnit##_FD_Z_F = VectorUnit##_FS_Z_F ;\
	} else {\
		VectorUnit##_FD_Z_F = VectorUnit##_FT_BC_F ;\
	}\
}\
if ( DEST_W ) { \
	if (  VectorUnit##_FS_W_F < VectorUnit##_FT_BC_F ) {\
		VectorUnit##_FD_W_F = VectorUnit##_FS_W_F ;\
	} else {\
		VectorUnit##_FD_W_F = VectorUnit##_FT_BC_F ;\
	}\
}\
}


#define vuMSUB(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * VectorUnit##_FT_X_F ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * VectorUnit##_FT_Y_F ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * VectorUnit##_FT_Z_F ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * VectorUnit##_FT_W_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuMSUBi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}




#define vuMSUBq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]) ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]) ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]) ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]) ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}




#define vuMSUBbc(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * VectorUnit##_FT_BC_F ) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * VectorUnit##_FT_BC_F ) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * VectorUnit##_FT_BC_F ) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * VectorUnit##_FT_BC_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}





#define vuMSUBA(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * VectorUnit##_FT_X_F ) ) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * VectorUnit##_FT_Y_F ) ) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * VectorUnit##_FT_Z_F ) ) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * VectorUnit##_FT_W_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMSUBAi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * VectorUnit##_I_F ) ) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * VectorUnit##_I_F ) ) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * VectorUnit##_I_F ) ) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * VectorUnit##_I_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMSUBAq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * VectorUnit##_Q_F ) ) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * VectorUnit##_Q_F ) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMSUBAbc(VectorUnit) {  \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_X_F * VectorUnit##_FT_BC_F))); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Y_F * VectorUnit##_FT_BC_F))); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_Z_F * VectorUnit##_FT_BC_F))); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_ACC_W_F - ( VectorUnit##_FS_W_F * VectorUnit##_FT_BC_F))); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuMUL(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_FT_X_F ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_FT_Y_F ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_FT_Z_F ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_FT_W_F ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMULq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_Q_F ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_Q_F ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_Q_F ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_Q_F ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMULi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * *(VectorUnit.CCR_p_float[ VU_I_REGISTER ]) ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}



#define vuMULbc(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_FT_BC_F) ); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_FT_BC_F) ); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_FT_BC_F) ); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_FT_BC_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}




#define vuMULA(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_FT_X_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_FT_Y_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_FT_Z_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_FT_W_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMULAi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_I_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_I_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_I_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_I_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMULAq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_Q_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_Q_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_Q_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_Q_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuMULAbc(VectorUnit) { \
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F * VectorUnit##_FT_BC_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_FT_BC_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_FT_BC_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F * VectorUnit##_FT_BC_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}




#define vuNOP(VectorUnit){ }



#define vuOPMULA(VectorUnit) { \
MAC_Reset( VectorUnit );\
VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_Y_F * VectorUnit##_FT_Z_F ) ); \
VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Z_F * VectorUnit##_FT_X_F ) ); \
VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_X_F * VectorUnit##_FT_Y_F ) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}



#define vuOPMSUB(VectorUnit) { \
MAC_Reset( VectorUnit );\
VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_ACC_X_F - ( VectorUnit##_FS_Y_F * VectorUnit##_FT_Z_F ))); \
VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_ACC_Y_F - ( VectorUnit##_FS_Z_F * VectorUnit##_FT_X_F ))); \
VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_ACC_Z_F - ( VectorUnit##_FS_X_F * VectorUnit##_FT_Y_F ))); \
VectorUnit##_UPDATE_STAT_REG(); \
}




#define vuSUB(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_FT_X_F )); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_FT_Y_F )); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_FT_Z_F )); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_FT_W_F )); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuSUBi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_I_F )); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_I_F )); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_I_F )); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_I_F )); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuSUBq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_Q_F )); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_Q_F )); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_Q_F )); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_Q_F )); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuSUBbc(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_FD_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F  - VectorUnit##_FT_BC_F)); \
if ( DEST_Y ) VectorUnit##_FD_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F  - VectorUnit##_FT_BC_F)); \
if ( DEST_Z ) VectorUnit##_FD_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F  - VectorUnit##_FT_BC_F)); \
if ( DEST_W ) VectorUnit##_FD_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F  - VectorUnit##_FT_BC_F)); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuSUBA(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_FT_X_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_FT_Y_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_FT_Z_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_FT_W_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuSUBAi(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_I_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_I_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_I_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_I_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}

#define vuSUBAq(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_Q_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_Q_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_Q_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_Q_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}


#define vuSUBAbc(VectorUnit) { \
MAC_Reset( VectorUnit );\
if ( DEST_X ) VectorUnit##_ACC_X_F = VectorUnit##_UPDATE_MAC_REG_X ( (double)( VectorUnit##_FS_X_F - VectorUnit##_FT_BC_F) ); \
if ( DEST_Y ) VectorUnit##_ACC_Y_F = VectorUnit##_UPDATE_MAC_REG_Y ( (double)( VectorUnit##_FS_Y_F - VectorUnit##_FT_BC_F) ); \
if ( DEST_Z ) VectorUnit##_ACC_Z_F = VectorUnit##_UPDATE_MAC_REG_Z ( (double)( VectorUnit##_FS_Z_F - VectorUnit##_FT_BC_F) ); \
if ( DEST_W ) VectorUnit##_ACC_W_F = VectorUnit##_UPDATE_MAC_REG_W ( (double)( VectorUnit##_FS_W_F - VectorUnit##_FT_BC_F) ); \
VectorUnit##_UPDATE_STAT_REG(); \
}














/******************************************************************************/
/*	LOWER INSTRUCTIONS														  */	
/******************************************************************************/

/*
WARNING : DON'T SURE IT IS A GOOD IDEA TO UPDATA STAT REG HERE

*/

char VUTOTODEBUG[200];

#define vuBAL(VectorUnit) { \
	_s32	Offset;	\
	_u32	TargetBranch;\
\
	Offset = (_VU_OPCODE_ & 0x07FF);\
	if (((_u32)Offset & 0x400 ) == 0x400 ) Offset = Offset | 0xFFFFFC00 ;\
\
	TargetBranch =(_u32) VectorUnit.PC + ((_s32)((_s32)Offset * 8) );\
	VectorUnit##_IT_I = VectorUnit.PC + 8 ; \
	/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/ \
\
	VectorUnit##_Execute_OneOpcode(); \
\
	VectorUnit.PC = TargetBranch; \
\
}

#define vuB(VectorUnit) { \
	_s32	Offset;	\
	_u32	TargetBranch;\
\
	Offset = (_VU_OPCODE_ & 0x07FF);\
	if (((_u32)Offset & 0x400 ) == 0x400 ) Offset = Offset | 0xFFFFFC00 ;\
\
	TargetBranch =(_u32) VectorUnit.PC  + ((_s32)((_s32)Offset * 8) );\
\
	/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/\
	VectorUnit##_Execute_OneOpcode(); \
\
	VectorUnit.PC = TargetBranch; \
\
}



#define vuDIV(VectorUnit){ \
if ( VectorUnit##_FT_FTF_F == 0.0 ) { \
	if ( VectorUnit##_FS_FSF_F == 0.0 )  { \
		VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] | 0x10; \
		VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] & (~0x20); \
		} else {\
		VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] | 0x20; \
		VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] & (~0x10); \
		} \
	} else {\
	VectorUnit##_Q_F =  ( VectorUnit##_FS_FSF_F / VectorUnit##_FT_FTF_F  ); \
	} \
VectorUnit##_UPDATE_STAT_REG_DI();\
}


#define	vuCLIP(VectorUnit) {\
\
VectorUnit##_CLIP_I = (_u32)(VectorUnit##_CLIP_I << 6 )  & 0xFFFFFF;\
\
if ( VectorUnit##_FS_X_F > +(fabs(VectorUnit##_FT_W_F) ) ) VectorUnit##_CLIP_I = VectorUnit##_CLIP_I | 0x1;\
if ( VectorUnit##_FS_X_F < -(fabs(VectorUnit##_FT_W_F) ) ) VectorUnit##_CLIP_I = VectorUnit##_CLIP_I | 0x2;\
\
if ( VectorUnit##_FS_Y_F > +(fabs(VectorUnit##_FT_W_F) ) ) VectorUnit##_CLIP_I = VectorUnit##_CLIP_I | 0x4;\
if ( VectorUnit##_FS_Y_F < -(fabs(VectorUnit##_FT_W_F) ) ) VectorUnit##_CLIP_I = VectorUnit##_CLIP_I | 0x8;\
\
if ( VectorUnit##_FS_Z_F > +(fabs(VectorUnit##_FT_W_F) ) ) VectorUnit##_CLIP_I = VectorUnit##_CLIP_I | 0x10;\
if ( VectorUnit##_FS_Z_F < -(fabs(VectorUnit##_FT_W_F) ) ) VectorUnit##_CLIP_I = VectorUnit##_CLIP_I | 0x20;\
\
}


#define vuERSADD(VectorUnit) { \
\
*(VectorUnit.CCR_p_float[ VU_P_REGISTER ]) = (float) (  1 / (  (VectorUnit##_FS_X_F * VectorUnit##_FS_X_F) +  (VectorUnit##_FS_Y_F * VectorUnit##_FS_Y_F)   +  (VectorUnit##_FS_Z_F * VectorUnit##_FS_Z_F)  ) ); \
\
}


#define vuESQRT(VectorUnit) { \
\
*(VectorUnit.CCR_p_float[ VU_P_REGISTER ]) = (float) ( sqrt( VectorUnit##_FS_FSF_F   ) ); \
\
}



#define vuFCAND(VectorUnit) {\
_u32 Mask; \
\
Mask = ((_u32)_VU_OPCODE_ & (_u32)0xFFFFFF) & (_u32)VectorUnit##_CLIP_I;\
\
if ( (_u32)Mask != (_u32)0 ) VectorUnit.CCR[ 1 ] = 1;\
else VectorUnit.CCR[ 1 ] = 0; \
\
\
}


#define vuFCGET(VectorUnit) {\
VectorUnit##_IT_I =(_u16)( VectorUnit##_CLIP_I & 0xFFF ); \
\
}





#define vuFCOR(VectorUnit) {\
_u32 Mask; \
\
Mask = ((_u32)_VU_OPCODE_ & (_u32)0xFFFFFF) & (_u32)VectorUnit##_CLIP_I;\
\
if ( (_u32)Mask == ( (_u32)_VU_OPCODE_ & (_u32)0xFFFFFF ) ) VectorUnit.CCR[ 1 ] = 1;\
else VectorUnit.CCR[ 1 ] = 0;\
\
\
}




#define vuFMAND(VectorUnit) { \
VectorUnit##_IT_I = (_u16)VectorUnit##_IS_I & (_u16)VectorUnit.CCR[VU_MAC_FLAG] ; \
}

#define vuIAND(VectorUnit) { \
	VectorUnit##_ID_I = (_u16)(VectorUnit##_IS_I & VectorUnit##_IT_I); \
}

#define vuIADD(VectorUnit) { \
	VectorUnit##_ID_I = (_u16)(VectorUnit##_IS_I + VectorUnit##_IT_I); \
}

#define vuIADDI(VectorUnit) { \
	_u16 imm = ((_VU_OPCODE_ >> 6) & 0x1f); \
\
	if ( imm & 0x10 ) imm = imm | 0xfff0;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %d  ", \
		debugTempTextVU1, CURRENT_VU_IS, (_s16)VectorUnit##_IS_I );*/ \
\
	VectorUnit##_IT_I = VectorUnit##_IS_I + (_u16)imm; \
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s VI[%d] = %d  \n", \
		debugTempTextVU1, CURRENT_VU_IT, (_s16)VectorUnit##_IT_I );*/ \
\
}


#define vuIADDIU(VectorUnit) { \
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %d  ", \
		debugTempTextVU1, CURRENT_VU_IS, (_s16)VectorUnit##_IS_I );*/ \
\
	VectorUnit##_IT_I = (_u16)(VectorUnit##_IS_I + (((_VU_OPCODE_ >> 10) & 0x7800) | (_VU_OPCODE_ & 0x7ff))); \
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s VI[%d] = %d  \n", \
		debugTempTextVU1, CURRENT_VU_IT, (_s16)VectorUnit##_IT_I );*/ \
\
\
}


#define vuIBEQ(VectorUnit) { \
	_u32	TargetBranch;\
\
	TargetBranch = _VU_OPCODE_  & 0x7ff ; \
	if ( TargetBranch & 0x400 ) TargetBranch = TargetBranch | 0xfffffc00;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  VI[%d] = %4.4x\n", \
		debugTempTextVU1, CURRENT_VU_IT, (_u16)VectorUnit##_IT_I, CURRENT_VU_IS, (_u16)VectorUnit##_IS_I);*/ \
\
	if ((_u16)VectorUnit##_IT_I == (_u16)VectorUnit##_IS_I) { \
		TargetBranch = VectorUnit.PC + ((_s32)TargetBranch * 8); \
 \
/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/\
		VectorUnit##_Execute_OneOpcode(); \
\
		VectorUnit.PC = TargetBranch; \
	} \
\
}




#define vuIBNE(VectorUnit) { \
	_u32	TargetBranch;\
\
	TargetBranch = _VU_OPCODE_  & 0x7ff ; \
	if ( TargetBranch & 0x400 ) TargetBranch = TargetBranch | 0xfffffc00;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  VI[%d] = %4.4x\n", \
		debugTempTextVU1, CURRENT_VU_IT, (_u16)VectorUnit##_IT_I, CURRENT_VU_IS, (_u16)VectorUnit##_IS_I);*/ \
\
	if ((_u16)VectorUnit##_IT_I != (_u16)VectorUnit##_IS_I) { \
		TargetBranch = VectorUnit.PC + ((_s32)TargetBranch * 8); \
 \
/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/\
		VectorUnit##_Execute_OneOpcode(); \
\
		VectorUnit.PC = TargetBranch; \
	} \
\
}


#define vuIBGTZ(VectorUnit) { \
	_u32	TargetBranch;\
\
	TargetBranch = _VU_OPCODE_  & 0x7ff ; \
	if ( TargetBranch & 0x400 ) TargetBranch = TargetBranch | 0xfffffc00;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  VI[%d] = %4.4x\n", \
		debugTempTextVU1, CURRENT_VU_IT, (_u16)VectorUnit##_IT_I, CURRENT_VU_IS, (_u16)VectorUnit##_IS_I); */\
\
	if ( (_s16)VectorUnit##_IS_I > 0) { \
		TargetBranch = VectorUnit.PC + ((_s32)TargetBranch * 8); \
 \
/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/\
		VectorUnit##_Execute_OneOpcode(); \
\
		VectorUnit.PC = TargetBranch; \
	} \
\
}

#define vuIBLTZ(VectorUnit) { \
	_u32	TargetBranch;\
\
	TargetBranch = _VU_OPCODE_  & 0x7ff ; \
	if ( TargetBranch & 0x400 ) TargetBranch = TargetBranch | 0xfffffc00;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  VI[%d] = %4.4x\n", \
		debugTempTextVU1, CURRENT_VU_IT, (_u16)VectorUnit##_IT_I, CURRENT_VU_IS, (_u16)VectorUnit##_IS_I);*/ \
\
	if ( (_s16)VectorUnit##_IS_I < 0) { \
		TargetBranch = VectorUnit.PC + ((_s32)TargetBranch * 8); \
 \
/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/\
		VectorUnit##_Execute_OneOpcode(); \
\
		VectorUnit.PC = TargetBranch; \
	} \
\
}

#define vuILW(VectorUnit) { \
	_u32	Addr;\
	u128v2	*temp128; \
	_u32 offset; \
\
	offset = _VU_OPCODE_  & 0x7ff; \
	if ( offset & 0x400 ) offset = offset | 0xfffffc00;\
\
	Addr = ((_u16)VectorUnit##_IS_I  + (_s32)offset )* 16 ;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IS, VectorUnit##_IS_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u32)Addr );\
\
	if ( DEST_X ) VectorUnit##_IT_I = (_u16)temp128->b32.w00;\
	if ( DEST_Y ) VectorUnit##_IT_I = (_u16)temp128->b32.w01;\
	if ( DEST_Z ) VectorUnit##_IT_I = (_u16)temp128->b32.w02;\
	if ( DEST_W ) VectorUnit##_IT_I = (_u16)temp128->b32.w03;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  \n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I ); */\
}


#define vuILWR(VectorUnit) { \
	_u32	Addr;\
	u128v2	*temp128; \
\
	Addr = (_u16)VectorUnit##_IS_I  * 16 ;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IS, VectorUnit##_IS_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u32)Addr );\
\
	if ( DEST_X ) VectorUnit##_IT_I = (_u16)temp128->b32.w00;\
	if ( DEST_Y ) VectorUnit##_IT_I = (_u16)temp128->b32.w01;\
	if ( DEST_Z ) VectorUnit##_IT_I = (_u16)temp128->b32.w02;\
	if ( DEST_W ) VectorUnit##_IT_I = (_u16)temp128->b32.w03;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  \n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I );*/ \
}


#define vuISUB(VectorUnit) { \
	VectorUnit##_ID_I = (_u16)(VectorUnit##_IS_I - VectorUnit##_IT_I); \
}




#define vuISUBIU(VectorUnit) { \
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %d  ", \
		debugTempTextVU1, CURRENT_VU_IS, (_s16)VectorUnit##_IS_I );*/ \
\
	VectorUnit##_IT_I = (_u16)(VectorUnit##_IS_I - (((_VU_OPCODE_ >> 10) & 0x7800) | (_VU_OPCODE_ & 0x7ff))); \
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s VI[%d] = %d  \n", \
		debugTempTextVU1, CURRENT_VU_IT, (_s16)VectorUnit##_IT_I );*/ \
\
\
}





#define vuISW(VectorUnit) { \
	_u32	Addr;\
	u128v2	*temp128; \
	_u32 offset; \
\
	offset = _VU_OPCODE_  & 0x7ff; \
	if ( offset & 0x400 ) offset = offset | 0xfffffc00;\
\
	Addr = ((_u16)VectorUnit##_IS_I  + (_s32)offset )* 16 ;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IS, VectorUnit##_IS_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u32)Addr );\
\
	if ( DEST_X ) (_u16)temp128->b32.w00 = VectorUnit##_IT_I;\
	if ( DEST_Y ) (_u16)temp128->b32.w01 = VectorUnit##_IT_I;\
	if ( DEST_Z ) (_u16)temp128->b32.w02 = VectorUnit##_IT_I;\
	if ( DEST_W ) (_u16)temp128->b32.w03 = VectorUnit##_IT_I;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  \n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I );*/ \
}




#define vuISWR(VectorUnit) { \
	_u32	Addr;\
	u128v2	*temp128; \
\
	Addr = (_u16)VectorUnit##_IS_I  * 16 ;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IS, VectorUnit##_IS_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u32)Addr );\
\
	if ( DEST_X ) (_u16)temp128->b32.w00 = VectorUnit##_IT_I;\
	if ( DEST_Y ) (_u16)temp128->b32.w01 = VectorUnit##_IT_I;\
	if ( DEST_Z ) (_u16)temp128->b32.w02 = VectorUnit##_IT_I;\
	if ( DEST_W ) (_u16)temp128->b32.w03 = VectorUnit##_IT_I;\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  \n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I );*/ \
}



#define vuJR(VectorUnit) { \
	_u32	TargetBranch; \
\
	TargetBranch = VectorUnit##_IS_I; \
/*if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);*/ \
	VectorUnit##_Execute_OneOpcode(); \
\
	VectorUnit.PC = TargetBranch; \
}

#define vuLQ(VectorUnit) { \
	_u32	Offset;	\
	_u32	Addr;\
\
	u128v2	*temp128; \
\
	Offset = (_VU_OPCODE_ & 0x07FF);\
	if (((_u32)Offset & 0x400 ) == 0x400 ) Offset = Offset | 0xFFFFFC00 ;\
\
	Addr = ((_u16)VectorUnit##_IS_I + (_u32)Offset ) * 16 ;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IS, VectorUnit##_IS_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + Addr );\
\
	if ( DEST_X ) VectorUnit##_FT_X_I = temp128->b32.w00;\
	if ( DEST_Y ) VectorUnit##_FT_Y_I = temp128->b32.w01;\
	if ( DEST_Z ) VectorUnit##_FT_Z_I = temp128->b32.w02;\
	if ( DEST_W ) VectorUnit##_FT_W_I = temp128->b32.w03;\
}

#define vuLQI(VectorUnit) { \
	_u32	Addr;\
\
	u128v2	*temp128; \
\
	Addr = (_u32)((_u16)VectorUnit##_IS_I  * 16 );\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IS, VectorUnit##_IS_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u32)Addr );\
\
	if ( DEST_X ) VectorUnit##_FT_X_I = temp128->b32.w00;\
	if ( DEST_Y ) VectorUnit##_FT_Y_I = temp128->b32.w01;\
	if ( DEST_Z ) VectorUnit##_FT_Z_I = temp128->b32.w02;\
	if ( DEST_W ) VectorUnit##_FT_W_I = temp128->b32.w03;\
\
	VectorUnit##_IS_I = (_u16)(VectorUnit##_IS_I + 1);\
}


#define vuMFP(VectorUnit) { \
if ( DEST_X ) VectorUnit##_FT_X_I = VectorUnit.CCR[VU_P_REGISTER] ; \
if ( DEST_Y ) VectorUnit##_FT_Y_I = VectorUnit.CCR[VU_P_REGISTER] ; \
if ( DEST_Z ) VectorUnit##_FT_Z_I = VectorUnit.CCR[VU_P_REGISTER] ; \
if ( DEST_W ) VectorUnit##_FT_W_I = VectorUnit.CCR[VU_P_REGISTER] ; \
}



#define vuMOVE(VectorUnit) { \
if ( DEST_X ) VectorUnit##_FT_X_F = VectorUnit##_FS_X_F ; \
if ( DEST_Y ) VectorUnit##_FT_Y_F = VectorUnit##_FS_Y_F ; \
if ( DEST_Z ) VectorUnit##_FT_Z_F = VectorUnit##_FS_Z_F ; \
if ( DEST_W ) VectorUnit##_FT_W_F = VectorUnit##_FS_W_F ; \
}

#define vuMR32(VectorUnit) { \
float	saved_x =  VectorUnit##_FS_X_F; \
if ( DEST_X ) VectorUnit##_FT_X_F = VectorUnit##_FS_Y_F ; \
if ( DEST_Y ) VectorUnit##_FT_Y_F = VectorUnit##_FS_Z_F ; \
if ( DEST_Z ) VectorUnit##_FT_Z_F = VectorUnit##_FS_W_F ; \
if ( DEST_W ) VectorUnit##_FT_W_F = saved_x ; \
}


#define vuRSQRT(VectorUnit){ \
if ( VectorUnit##_FT_FTF_F < 0.0 ) \
VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] | 0x10; \
else VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] & (~0x10); \
VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] & (~0x20); \
VectorUnit##_Q_F =  ( VectorUnit##_FS_FSF_F / (float)sqrt(fabs(VectorUnit##_FT_FTF_F ) ));\
VectorUnit##_UPDATE_STAT_REG_DI();\
}


#define vuRINIT(VectorUnit){ \
VectorUnit.CCR[ VU_R_REGISTER ] = ( VectorUnit.CPR[CURRENT_VU_FS][CURRENT_VU_FSF] & 0x7FFFFF ); \
}

#define vuRGET(VectorUnit){ \
	if ( DEST_X ) VectorUnit##_FT_X_I = VectorUnit.CCR[VU_R_REGISTER] ; \
	if ( DEST_Y ) VectorUnit##_FT_Y_I = VectorUnit.CCR[VU_R_REGISTER] ; \
	if ( DEST_Z ) VectorUnit##_FT_Z_I = VectorUnit.CCR[VU_R_REGISTER] ; \
	if ( DEST_W ) VectorUnit##_FT_W_I = VectorUnit.CCR[VU_R_REGISTER] ; \
}

#define vuRNEXT(VectorUnit){ \	
	float rtemp = 1.0f+(float)(1.0f*rand()/(RAND_MAX+1.0f)); \
	VectorUnit.CCR[VU_R_REGISTER] = *((_u32 *)(&rtemp)); \
	if ( DEST_X ) VectorUnit##_FT_X_I = VectorUnit.CCR[VU_R_REGISTER] ; \
	if ( DEST_Y ) VectorUnit##_FT_Y_I = VectorUnit.CCR[VU_R_REGISTER] ; \
	if ( DEST_Z ) VectorUnit##_FT_Z_I = VectorUnit.CCR[VU_R_REGISTER] ; \
	if ( DEST_W ) VectorUnit##_FT_W_I = VectorUnit.CCR[VU_R_REGISTER] ; \
}

#define vuRXOR(VectorUnit) { \
	VectorUnit.CCR[ VU_R_REGISTER ] ^= VectorUnit.CPR[CURRENT_VU_FS][CURRENT_VU_FSF]; \
}

#define	vuSQ(VectorUnit) { \
	_u32	Offset;	\
	_u32	Addr;\
\
	u128v2	*temp128; \
\
	Offset = (_VU_OPCODE_ & 0x07FF);\
	if (((_u32)Offset & 0x400 ) == 0x400 ) Offset = Offset | 0xFFFFFC00 ;\
\
\
	Addr = ((_u16)VectorUnit##_IT_I + (_u32)Offset ) * 16 ;\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I,Addr );*/ \
\
	temp128 = (u128v2 *)((_u8 *)( VectorUnit.Mem + (_u16)Addr ));\
\
	if ( DEST_X )  temp128->b32.w00 = VectorUnit##_FS_X_I;\
	if ( DEST_Y )  temp128->b32.w01 = VectorUnit##_FS_Y_I ;\
	if ( DEST_Z )  temp128->b32.w02 = VectorUnit##_FS_Z_I;\
	if ( DEST_W )  temp128->b32.w03 = VectorUnit##_FS_W_I;\
\
}




#define	vuSQI(VectorUnit) { \
	_u16	Addr;\
\
	u128v2	*temp128; \
\
	Addr = (_u16)((_u16)VectorUnit##_IT_I  * 16 );\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u16)Addr );\
\
	if ( DEST_X )  temp128->b32.w00 = VectorUnit##_FS_X_I;\
	if ( DEST_Y )  temp128->b32.w01 = VectorUnit##_FS_Y_I ;\
	if ( DEST_Z )  temp128->b32.w02 = VectorUnit##_FS_Z_I;\
	if ( DEST_W )  temp128->b32.w03 = VectorUnit##_FS_W_I;\
\
	VectorUnit##_IT_I = (_u16)(VectorUnit##_IT_I + 1);\
}

#define	vuSQD(VectorUnit) { \
	_u16	Addr;\
\
	u128v2	*temp128; \
\
	VectorUnit##_IT_I = (_u16)(VectorUnit##_IT_I - 1);\
\
	Addr = (_u16)((_u16)VectorUnit##_IT_I  * 16 );\
\
/*if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"%s | VI[%d] = %4.4x  Addr = %8.8lx.\n", \
		debugTempTextVU1, CURRENT_VU_IT, VectorUnit##_IT_I,Addr );*/ \
\
	temp128 = (u128v2 *)( VectorUnit.Mem + (_u16)Addr );\
\
	if ( DEST_X )  temp128->b32.w00 = VectorUnit##_FS_X_I;\
	if ( DEST_Y )  temp128->b32.w01 = VectorUnit##_FS_Y_I ;\
	if ( DEST_Z )  temp128->b32.w02 = VectorUnit##_FS_Z_I;\
	if ( DEST_W )  temp128->b32.w03 = VectorUnit##_FS_W_I;\
\
}




#define vuSQRT(VectorUnit) { \
if ( VectorUnit##_FT_FTF_F < 0.0 ) \
VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] | 0x10; \
else VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] & (~0x10); \
VectorUnit.CCR[VU_STATUS_FLAG] = VectorUnit.CCR[VU_STATUS_FLAG] & (~0x20); \
VectorUnit##_Q_F = (float)sqrt(fabs(VectorUnit##_FT_FTF_F)) ; \
VectorUnit##_UPDATE_STAT_REG_DI();\
}



#define vuWAITQ(VectorUnit) { }

#define vuWAITP(VectorUnit) { }
#endif


