//---------------------------------------------------------------------------

#include <vcl.h>
  

#pragma hdrstop

#include "FormMainWindow.h"
#include "About.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include "../nsx2.h"
#include "../_Debuger/debuger.h"


#include "r5900/r5900_main.hpp"
#include "Loader/Loader.h"


extern pluginDebuger *FromEmu ;

TForm_Debug *Form_Debug;

_u32	DBG_DisasmStartAdress;



/*****************************************************************************/
typedef struct _DBG_BreakPoint {

	BOOL	Status;
	_u32	Adress;
	_u32	Opcode;

}DBG_BreakPoint;

_u32		DBG_BreakPoint_Number = 0;
DBG_BreakPoint	Inspector_BP[256];

void	DBG_BP_Init() {
	int boucle;

	for ( boucle = 0 ; boucle < 256 ; boucle++ ) {
		Inspector_BP[ boucle ].Status = false;
        Inspector_BP[ boucle ].Adress = 0;
        Inspector_BP[ boucle ].Opcode = 0;
	}

    DBG_BreakPoint_Number = 0;
}



void	DBG_BP_Add_BreakPoint ( _u32 fAdress ) {

		Inspector_BP[ DBG_BreakPoint_Number ].Status = true;
        Inspector_BP[ DBG_BreakPoint_Number ].Adress = fAdress;
        Inspector_BP[ DBG_BreakPoint_Number ].Opcode = *( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)fAdress & 0x01FFFFFF)) ));

		/*Change Memory HERE */
        *( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)fAdress & 0x01FFFFFF)) )) = 0x0000000D;

		DBG_BreakPoint_Number++;
}

void	DBG_BP_Remove_BreakPoint ( _u32 fAdress ) {
	int boucle;

	for ( boucle = 0 ; boucle < 256 ; boucle++ ) {

		if ( Inspector_BP[ boucle ].Adress == fAdress ) {
			/* RESTORE OPCODES HERE */

			*( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)fAdress & 0x01FFFFFF)) )) = Inspector_BP[ boucle ].Opcode;

			Inspector_BP[ boucle ].Status = false;
        	Inspector_BP[ boucle ].Adress = 0;
        	Inspector_BP[ boucle ].Opcode = 0;

 /*
  MessageDlg("Remove " ,
               mtInformation, TMsgDlgButtons() , 0);
  */

        	break;
		}


	}


}




/******************************************************************************/


void DBG_Send_BreakPoint (  ) {
	int boucle;


//	if ( FromEmu == NULL ) return;

    /* Restore All Opcodes */
	for ( boucle = 0 ; boucle < 256 ; boucle ++ ) {
 		if ( Inspector_BP[ boucle ].Adress == FromEmu->MipsCpu->PC ) {
			/* RESTORE OPCODES HERE */

//  MessageDlg("BreakFound-Restore " ,
//               mtInformation, TMsgDlgButtons() , 0);


			*( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)Inspector_BP[ boucle ].Adress & 0x01FFFFFF)) )) = Inspector_BP[ boucle ].Opcode;
          	break;
		}
	}



	FromEmu->MipsCpu->PC = FromEmu->MipsCpu->PC - 4;
    FromEmu->MipsCpu->halt = 2;

	Form_Debug->Bevel6->Style = bsLowered;
	Form_Debug->Bevel4->Style = bsRaised;

	Form_Debug->Timer1->Enabled = true;

}
 


/******************************************************************************/
void	DBG_UpdatePC(void) {
 	char	TempText[1024];
	sprintf(TempText,"%8.8lx",FromEmu->MipsCpu->PC );

	Form_Debug->R5900_PC->Text = TempText;


}

#define	UPDATE_R5900_CORE(A,B)   	sprintf(TempText,"%8.8lx %8.8lx %8.8lx %8.8lx",\
		(_u32)((_u64)FromEmu->MipsCpu->GPR[A].hi>>32),\
		(_u32)((_u64)FromEmu->MipsCpu->GPR[A].hi&0xFFFFFFFF),\
		(_u32)((_u64)FromEmu->MipsCpu->GPR[A].lo>>32),        \
		(_u32)((_u64)FromEmu->MipsCpu->GPR[A].lo&0xFFFFFFFF)   \
		 );                                         \
 	Form_Debug->B->Text = TempText

void	DBG_Update_R5900( void ) {

	char	TempText[1024];


	if ( Form_Debug->TabSheet_R5900Core->Visible == TRUE ) {

		UPDATE_R5900_CORE(CPU_REG_R0,Core_R0); UPDATE_R5900_CORE(CPU_REG_AT,Core_AT);
		UPDATE_R5900_CORE(CPU_REG_V0,Core_V0); UPDATE_R5900_CORE(CPU_REG_V1,Core_V1);
		UPDATE_R5900_CORE(CPU_REG_A0,Core_A0); UPDATE_R5900_CORE(CPU_REG_A1,Core_A1);
		UPDATE_R5900_CORE(CPU_REG_A2,Core_A2); UPDATE_R5900_CORE(CPU_REG_A3,Core_A3);
		UPDATE_R5900_CORE(CPU_REG_T0,Core_T0); UPDATE_R5900_CORE(CPU_REG_T1,Core_T1);
		UPDATE_R5900_CORE(CPU_REG_T2,Core_T2); UPDATE_R5900_CORE(CPU_REG_T3,Core_T3);
		UPDATE_R5900_CORE(CPU_REG_T4,Core_T4); UPDATE_R5900_CORE(CPU_REG_T5,Core_T5);
		UPDATE_R5900_CORE(CPU_REG_T6,Core_T6); UPDATE_R5900_CORE(CPU_REG_T7,Core_T7);
		UPDATE_R5900_CORE(CPU_REG_S0,Core_S0); UPDATE_R5900_CORE(CPU_REG_S1,Core_S1);
		UPDATE_R5900_CORE(CPU_REG_S2,Core_S2); UPDATE_R5900_CORE(CPU_REG_S3,Core_S3);
		UPDATE_R5900_CORE(CPU_REG_S4,Core_S4); UPDATE_R5900_CORE(CPU_REG_S5,Core_S5);
		UPDATE_R5900_CORE(CPU_REG_S6,Core_S6); UPDATE_R5900_CORE(CPU_REG_S7,Core_S7);
		UPDATE_R5900_CORE(CPU_REG_T8,Core_T8); UPDATE_R5900_CORE(CPU_REG_T9,Core_T9);
		UPDATE_R5900_CORE(CPU_REG_K0,Core_K0); UPDATE_R5900_CORE(CPU_REG_K1,Core_K1);
		UPDATE_R5900_CORE(CPU_REG_GP,Core_GP); UPDATE_R5900_CORE(CPU_REG_SP,Core_SP);
		UPDATE_R5900_CORE(CPU_REG_S8,Core_S8); UPDATE_R5900_CORE(CPU_REG_RA,Core_RA);
		UPDATE_R5900_CORE(CPU_REG_HI,Core_HI); UPDATE_R5900_CORE(CPU_REG_LO,Core_LO);


	}

}


#define	UPDATE_R5900_COP0(A,B)   	sprintf(TempText,"%8.8lx %8.8lx",\
		(_u32)((_u64)FromEmu->MipsCpu->CPR0[A][0]>>32),        \
		(_u32)((_u64)FromEmu->MipsCpu->CPR0[A][0]&0xFFFFFFFF)   \
		 );                                         \
 	Form_Debug->B->Text = TempText

void	DBG_Update_R5900_COP0( void ) {

	char	TempText[1024];


	if ( Form_Debug->TabSheet_R5900_COP0->Visible == TRUE ) {

		UPDATE_R5900_COP0(0,COP0_00); UPDATE_R5900_COP0(16,COP0_16);
		UPDATE_R5900_COP0(1,COP0_01); UPDATE_R5900_COP0(17,COP0_17);
		UPDATE_R5900_COP0(2,COP0_02); UPDATE_R5900_COP0(18,COP0_18);
		UPDATE_R5900_COP0(3,COP0_03); UPDATE_R5900_COP0(19,COP0_19);
		UPDATE_R5900_COP0(4,COP0_04); UPDATE_R5900_COP0(20,COP0_20);
		UPDATE_R5900_COP0(5,COP0_05); UPDATE_R5900_COP0(21,COP0_21);
		UPDATE_R5900_COP0(6,COP0_06); UPDATE_R5900_COP0(22,COP0_22);
		UPDATE_R5900_COP0(7,COP0_07); UPDATE_R5900_COP0(23,COP0_23);
		UPDATE_R5900_COP0(8,COP0_08); UPDATE_R5900_COP0(24,COP0_24);
		UPDATE_R5900_COP0(9,COP0_09); UPDATE_R5900_COP0(25,COP0_25);
		UPDATE_R5900_COP0(10,COP0_10); UPDATE_R5900_COP0(26,COP0_26);
		UPDATE_R5900_COP0(11,COP0_11); UPDATE_R5900_CORE(27,COP0_27);
		UPDATE_R5900_COP0(12,COP0_12); UPDATE_R5900_COP0(28,COP0_28);
		UPDATE_R5900_COP0(13,COP0_13); UPDATE_R5900_COP0(29,COP0_29);
		UPDATE_R5900_COP0(14,COP0_14); UPDATE_R5900_COP0(30,COP0_30);
		UPDATE_R5900_COP0(15,COP0_15); UPDATE_R5900_COP0(31,COP0_31);



	}

}



#define UPDATE_R5900_COP1(A,B,C)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->MipsCpu->FPR1[A] );\
 		Form_Debug->B->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->MipsCpu->FPR1_p_float[A]) ); \
 		Form_Debug->C->Text = TempText \

#define	UPDATE_R5900_COP1_CR(A,B)\
		sprintf(TempText,"%8.8lx %8.8lx",\
				(_u32)((_u64)FromEmu->MipsCpu->CP1[A]>>32),\
				(_u32)((_u64)FromEmu->MipsCpu->CP1[A]&0xFFFFFFFF ));\
 		Form_Debug->B->Text = TempText \



void	DBG_Update_R5900_COP1( void ) {
 	char	TempText[1024];

		if ( Form_Debug->TabSheet_R5900_COP1->Visible == TRUE ) {

 			UPDATE_R5900_COP1(0,COP1_00_h,COP1_00_f);	UPDATE_R5900_COP1(1,COP1_01_h,COP1_01_f);
			UPDATE_R5900_COP1(2,COP1_02_h,COP1_02_f);   UPDATE_R5900_COP1(3,COP1_03_h,COP1_03_f);
			UPDATE_R5900_COP1(4,COP1_04_h,COP1_04_f);   UPDATE_R5900_COP1(5,COP1_05_h,COP1_05_f);
			UPDATE_R5900_COP1(6,COP1_06_h,COP1_06_f);   UPDATE_R5900_COP1(7,COP1_07_h,COP1_07_f);
			UPDATE_R5900_COP1(8,COP1_08_h,COP1_08_f);   UPDATE_R5900_COP1(9,COP1_09_h,COP1_09_f);
			UPDATE_R5900_COP1(10,COP1_10_h,COP1_10_f);  UPDATE_R5900_COP1(11,COP1_11_h,COP1_11_f);
			UPDATE_R5900_COP1(12,COP1_12_h,COP1_12_f);  UPDATE_R5900_COP1(13,COP1_13_h,COP1_13_f);
			UPDATE_R5900_COP1(14,COP1_14_h,COP1_14_f);  UPDATE_R5900_COP1(15,COP1_15_h,COP1_15_f);
			UPDATE_R5900_COP1(16,COP1_16_h,COP1_16_f);  UPDATE_R5900_COP1(17,COP1_17_h,COP1_17_f);
			UPDATE_R5900_COP1(18,COP1_18_h,COP1_18_f);  UPDATE_R5900_COP1(19,COP1_19_h,COP1_19_f);
			UPDATE_R5900_COP1(20,COP1_20_h,COP1_20_f);  UPDATE_R5900_COP1(21,COP1_21_h,COP1_21_f);
			UPDATE_R5900_COP1(22,COP1_22_h,COP1_22_f);  UPDATE_R5900_COP1(23,COP1_23_h,COP1_23_f);
			UPDATE_R5900_COP1(24,COP1_24_h,COP1_24_f);  UPDATE_R5900_COP1(25,COP1_25_h,COP1_25_f);
			UPDATE_R5900_COP1(26,COP1_26_h,COP1_26_f);  UPDATE_R5900_COP1(27,COP1_27_h,COP1_27_f);
			UPDATE_R5900_COP1(28,COP1_28_h,COP1_28_f);  UPDATE_R5900_COP1(29,COP1_29_h,COP1_29_f);
			UPDATE_R5900_COP1(30,COP1_30_h,COP1_30_f);  UPDATE_R5900_COP1(31,COP1_31_h,COP1_31_f);

			/* ACC */
 			sprintf(TempText,"%8.8lx",(_u32)FromEmu->MipsCpu->FPR1_ACC);
 			Form_Debug->COP1_ACC_h->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->MipsCpu->FPR1_ACC_p_float) ); \
 			Form_Debug->COP1_ACC_f->Text = TempText ;

            UPDATE_R5900_COP1_CR(CP1_FIR,COP1_FIR);		UPDATE_R5900_COP1_CR(CP1_FCCR,COP1_FCCR);
            UPDATE_R5900_COP1_CR(CP1_FEXR,COP1_FEXR);   UPDATE_R5900_COP1_CR(CP1_FENR,COP1_FENR);
            UPDATE_R5900_COP1_CR(CP1_FCSR,COP1_FCSR);

		}

}

#define	UPDATE_DMAC_CR(A,B)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->DmaC->Reg->A);\
 		Form_Debug->B->Text = TempText \

/*channel,reg,Edit*/
#define	UPDATE_DMAC_CH_RG(A,B,C)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->DmaC->Channel[A]->B);\
 		Form_Debug->C->Text = TempText \


void	DBG_Update_DMAC( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_DMAC->Visible == TRUE ) {

    	UPDATE_DMAC_CR(ctrl,Dmac_CTRL);			UPDATE_DMAC_CR(stat,Dmac_STAT);
    	UPDATE_DMAC_CR(pcr,Dmac_PCR);           UPDATE_DMAC_CR(sqwc,Dmac_SQWC);
    	UPDATE_DMAC_CR(rbsr,Dmac_RBSR);         UPDATE_DMAC_CR(rbor,Dmac_RBOR);
    	UPDATE_DMAC_CR(stadr,Dmac_STAD);


		UPDATE_DMAC_CH_RG(0,ctrl,	CH0_CHCR);  UPDATE_DMAC_CH_RG(0,memAdd,	CH0_MADR);
		UPDATE_DMAC_CH_RG(0,size,	CH0_QWC);   UPDATE_DMAC_CH_RG(0,tag,	CH0_TADR);
		UPDATE_DMAC_CH_RG(0,asr0,	CH0_ASR0);  UPDATE_DMAC_CH_RG(0,asr1,	CH0_ASR1);
		UPDATE_DMAC_CH_RG(0,saddr,	CH0_SADR);

		UPDATE_DMAC_CH_RG(1,ctrl,	CH1_CHCR);  UPDATE_DMAC_CH_RG(1,memAdd,	CH1_MADR);
		UPDATE_DMAC_CH_RG(1,size,	CH1_QWC);   UPDATE_DMAC_CH_RG(1,tag,	CH1_TADR);
		UPDATE_DMAC_CH_RG(1,asr0,	CH1_ASR0);  UPDATE_DMAC_CH_RG(1,asr1,	CH1_ASR1);
		UPDATE_DMAC_CH_RG(1,saddr,	CH1_SADR);

		UPDATE_DMAC_CH_RG(2,ctrl,	CH2_CHCR);   UPDATE_DMAC_CH_RG(2,memAdd,	CH2_MADR);
		UPDATE_DMAC_CH_RG(2,size,	CH2_QWC);    UPDATE_DMAC_CH_RG(2,tag,	CH2_TADR);
		UPDATE_DMAC_CH_RG(2,asr0,	CH2_ASR0);   UPDATE_DMAC_CH_RG(2,asr1,	CH2_ASR1);
		UPDATE_DMAC_CH_RG(2,saddr,	CH2_SADR);

		UPDATE_DMAC_CH_RG(3,ctrl,	CH3_CHCR);   UPDATE_DMAC_CH_RG(3,memAdd,	CH3_MADR);
		UPDATE_DMAC_CH_RG(3,size,	CH3_QWC);    UPDATE_DMAC_CH_RG(3,tag,	CH3_TADR);
		UPDATE_DMAC_CH_RG(3,asr0,	CH3_ASR0);   UPDATE_DMAC_CH_RG(3,asr1,	CH3_ASR1);
		UPDATE_DMAC_CH_RG(3,saddr,	CH3_SADR);

		UPDATE_DMAC_CH_RG(4,ctrl,	CH4_CHCR);   UPDATE_DMAC_CH_RG(4,memAdd,	CH4_MADR);
		UPDATE_DMAC_CH_RG(4,size,	CH4_QWC);    UPDATE_DMAC_CH_RG(4,tag,	CH4_TADR);
		UPDATE_DMAC_CH_RG(4,asr0,	CH4_ASR0);   UPDATE_DMAC_CH_RG(4,asr1,	CH4_ASR1);
		UPDATE_DMAC_CH_RG(4,saddr,	CH4_SADR);

		UPDATE_DMAC_CH_RG(5,ctrl,	CH5_CHCR);   UPDATE_DMAC_CH_RG(5,memAdd,	CH5_MADR);
		UPDATE_DMAC_CH_RG(5,size,	CH5_QWC);    UPDATE_DMAC_CH_RG(5,tag,	CH5_TADR);
		UPDATE_DMAC_CH_RG(5,asr0,	CH5_ASR0);   UPDATE_DMAC_CH_RG(5,asr1,	CH5_ASR1);
		UPDATE_DMAC_CH_RG(5,saddr,	CH5_SADR);

		UPDATE_DMAC_CH_RG(6,ctrl,	CH6_CHCR);   UPDATE_DMAC_CH_RG(6,memAdd,	CH6_MADR);
		UPDATE_DMAC_CH_RG(6,size,	CH6_QWC);    UPDATE_DMAC_CH_RG(6,tag,	CH6_TADR);
		UPDATE_DMAC_CH_RG(6,asr0,	CH6_ASR0);   UPDATE_DMAC_CH_RG(6,asr1,	CH6_ASR1);
		UPDATE_DMAC_CH_RG(6,saddr,	CH6_SADR);

		UPDATE_DMAC_CH_RG(7,ctrl,	CH7_CHCR);   UPDATE_DMAC_CH_RG(7,memAdd,	CH7_MADR);
		UPDATE_DMAC_CH_RG(7,size,	CH7_QWC);    UPDATE_DMAC_CH_RG(7,tag,	CH7_TADR);
		UPDATE_DMAC_CH_RG(7,asr0,	CH7_ASR0);   UPDATE_DMAC_CH_RG(7,asr1,	CH7_ASR1);
		UPDATE_DMAC_CH_RG(7,saddr,	CH7_SADR);

		UPDATE_DMAC_CH_RG(8,ctrl,	CH8_CHCR);   UPDATE_DMAC_CH_RG(8,memAdd,	CH8_MADR);
		UPDATE_DMAC_CH_RG(8,size,	CH8_QWC);    UPDATE_DMAC_CH_RG(8,tag,	CH8_TADR);
		UPDATE_DMAC_CH_RG(8,asr0,	CH8_ASR0);   UPDATE_DMAC_CH_RG(8,asr1,	CH8_ASR1);
		UPDATE_DMAC_CH_RG(8,saddr,	CH8_SADR);

		UPDATE_DMAC_CH_RG(9,ctrl,	CH9_CHCR);   UPDATE_DMAC_CH_RG(9,memAdd,	CH9_MADR);
		UPDATE_DMAC_CH_RG(9,size,	CH9_QWC);    UPDATE_DMAC_CH_RG(9,tag,	CH9_TADR);
		UPDATE_DMAC_CH_RG(9,asr0,	CH9_ASR0);   UPDATE_DMAC_CH_RG(9,asr1,	CH9_ASR1);
		UPDATE_DMAC_CH_RG(9,saddr,	CH9_SADR);

	}

}

#define	UPDATE_INT0(INTC,B) \
 		Form_Debug->INTC##_STAT->Text = IntToStr(FromEmu->IntC->IntByCause[B].Status);\
 		Form_Debug->INTC##_NB->Text = IntToStr(FromEmu->IntC->IntByCause[B].Nb_handler);\
		if ( FromEmu->IntC->IntByCause[B].HandlerAdd != NULL ) {\
        	Form_Debug->INTC##_ID->Text =  IntToStr(FromEmu->IntC->IntByCause[B].HandlerAdd->ID);\
			sprintf(TempText,"%8.8lx",(_u32)FromEmu->IntC->IntByCause[B].HandlerAdd->Add);\
 			Form_Debug->INTC##_ADD->Text = TempText; \
		}\

#define	UPDATE_INT1(INTC,B) \
 		Form_Debug->INTC##_STAT->Text = IntToStr(FromEmu->IntC->IntByDMA[B].Status);\
 		Form_Debug->INTC##_NB->Text = IntToStr(FromEmu->IntC->IntByDMA[B].Nb_handler);\
		if ( FromEmu->IntC->IntByDMA[B].HandlerAdd != NULL ) {\
        	Form_Debug->INTC##_ID->Text =  IntToStr(FromEmu->IntC->IntByDMA[B].HandlerAdd->ID);\
			sprintf(TempText,"%8.8lx",(_u32)FromEmu->IntC->IntByDMA[B].HandlerAdd->Add);\
 			Form_Debug->INTC##_ADD->Text = TempText; \
		}\



void	DBG_Update_INTC( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_INTC->Visible == TRUE ) {

        /* Regs */
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->IntC->Reg->stat);
		Form_Debug->Intc_STAT->Text = TempText;
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->IntC->Reg->mask);
		Form_Debug->Intc_MASK->Text = TempText;


    	UPDATE_INT0(INT0,0);	UPDATE_INT0(INT1,1);	UPDATE_INT0(INT2,2);
    	UPDATE_INT0(INT3,3);	UPDATE_INT0(INT4,4);	UPDATE_INT0(INT5,5);
    	UPDATE_INT0(INT6,6);	UPDATE_INT0(INT7,7);	UPDATE_INT0(INT8,8);
		UPDATE_INT0(INT9,9);	UPDATE_INT0(INT10,10);

 		UPDATE_INT1(INTCH0,0);	UPDATE_INT1(INTCH1,1);	UPDATE_INT1(INTCH2,2);
 		UPDATE_INT1(INTCH3,3);	UPDATE_INT1(INTCH4,4);	UPDATE_INT1(INTCH5,5);
 		UPDATE_INT1(INTCH6,6);	UPDATE_INT1(INTCH7,7);	UPDATE_INT1(INTCH8,8);
 		UPDATE_INT1(INTCH9,9);

	}
}

#define	UPDATE_TIMERS_REG(TIMER_ID,B)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->Timer[B]->Reg->count);\
 		Form_Debug->TIMER_ID##_COUNT->Text = TempText; \
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->Timer[B]->Reg->comp);\
 		Form_Debug->TIMER_ID##_COMP->Text = TempText; \
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->Timer[B]->Reg->hold);\
 		Form_Debug->TIMER_ID##_HOLD->Text = TempText; \
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->Timer[B]->Reg->mode);\
 		Form_Debug->TIMER_ID##_MODE->Text = TempText; \



void	DBG_Update_TIMERS( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_INTC->Visible == TRUE ) {

    UPDATE_TIMERS_REG(Timer0,0);
    UPDATE_TIMERS_REG(Timer1,1);
    UPDATE_TIMERS_REG(Timer2,2);
    UPDATE_TIMERS_REG(Timer3,3);


	}
}

#define	UPDATE_VIF_REG(VIFID,A,EDITID) \
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->VIF[VIFID]->Reg->A);  \
 		Form_Debug->EDITID##->Text = TempText;  \



void	DBG_Update_VIF( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_VIF->Visible == TRUE ) {

		UPDATE_VIF_REG(0,stat,	Vif0_STAT);		UPDATE_VIF_REG(0,fbrst,	Vif0_FBRST);
		UPDATE_VIF_REG(0,err,	Vif0_ERR);      UPDATE_VIF_REG(0,mark,	Vif0_MARK);
		UPDATE_VIF_REG(0,cycle,	Vif0_CYCLE);    UPDATE_VIF_REG(0,mode,	Vif0_MODE);
		UPDATE_VIF_REG(0,num,	Vif0_NUM);      UPDATE_VIF_REG(0,mask,	Vif0_MASK);
       	UPDATE_VIF_REG(0,code,	Vif0_CODE);     UPDATE_VIF_REG(0,itops,	Vif0_ITOPS);
        UPDATE_VIF_REG(0,base,	Vif0_BASE);     UPDATE_VIF_REG(0,ofst,	Vif0_OFST);
        UPDATE_VIF_REG(0,tops,	Vif0_TOPS);     UPDATE_VIF_REG(0,itop,	Vif0_ITOP);
        UPDATE_VIF_REG(0,top,	Vif0_TOP);      UPDATE_VIF_REG(0,r0,	Vif0_R0);
        UPDATE_VIF_REG(0,r1,	Vif0_R1);       UPDATE_VIF_REG(0,r2,	Vif0_R2);
        UPDATE_VIF_REG(0,r3,	Vif0_R3);       UPDATE_VIF_REG(0,c0,	Vif0_C0);
        UPDATE_VIF_REG(0,c1,	Vif0_C1);       UPDATE_VIF_REG(0,c2,	Vif0_C2);
        UPDATE_VIF_REG(0,c3,	Vif0_C3);

		UPDATE_VIF_REG(1,stat,	Vif1_STAT);     UPDATE_VIF_REG(1,fbrst,	Vif1_FBRST);
		UPDATE_VIF_REG(1,err,	Vif1_ERR);      UPDATE_VIF_REG(1,mark,	Vif1_MARK);
		UPDATE_VIF_REG(1,cycle,	Vif1_CYCLE);    UPDATE_VIF_REG(1,mode,	Vif1_MODE);
		UPDATE_VIF_REG(1,num,	Vif1_NUM);      UPDATE_VIF_REG(1,mask,	Vif1_MASK);
       	UPDATE_VIF_REG(1,code,	Vif1_CODE);     UPDATE_VIF_REG(1,itops,	Vif1_ITOPS);
        UPDATE_VIF_REG(1,base,	Vif1_BASE);     UPDATE_VIF_REG(1,ofst,	Vif1_OFST);
        UPDATE_VIF_REG(1,tops,	Vif1_TOPS);     UPDATE_VIF_REG(1,itop,	Vif1_ITOP);
        UPDATE_VIF_REG(1,top,	Vif1_TOP);      UPDATE_VIF_REG(1,r0,	Vif1_R0);
        UPDATE_VIF_REG(1,r1,	Vif1_R1);       UPDATE_VIF_REG(1,r2,	Vif1_R2);
        UPDATE_VIF_REG(1,r3,	Vif1_R3);       UPDATE_VIF_REG(1,c0,	Vif1_C0);
        UPDATE_VIF_REG(1,c1,	Vif1_C1);       UPDATE_VIF_REG(1,c2,	Vif1_C2);
        UPDATE_VIF_REG(1,c3,	Vif1_C3);


	}



}


#define	UPDATE_VU0_F(REGID,EDITID)\
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->CPR_p_float[REGID][0]) ); \
 		Form_Debug->EDITID##_0->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->CPR_p_float[REGID][1]) ); \
 		Form_Debug->EDITID##_1->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->CPR_p_float[REGID][2]) ); \
 		Form_Debug->EDITID##_2->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->CPR_p_float[REGID][3]) ); \
 		Form_Debug->EDITID##_3->Text = TempText \


#define	UPDATE_VU0_I(REGID,EDITID)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->VectorUnit0->CCR[REGID]);  \
 		Form_Debug->EDITID##->Text = TempText;


void	DBG_Update_VU0( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_VU0->Visible == TRUE ) {

			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->ACC_p_float[0]) );
 			Form_Debug->VU0_ACC_0->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->ACC_p_float[1]) );
 			Form_Debug->VU0_ACC_1->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->ACC_p_float[2]) );
 			Form_Debug->VU0_ACC_2->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit0->ACC_p_float[3]) );
 			Form_Debug->VU0_ACC_3->Text = TempText;

			UPDATE_VU0_F(0,VU0_F00);	UPDATE_VU0_F(1,VU0_F01);	UPDATE_VU0_F(2,VU0_F02);
			UPDATE_VU0_F(3,VU0_F03);	UPDATE_VU0_F(4,VU0_F04);	UPDATE_VU0_F(5,VU0_F05);
			UPDATE_VU0_F(6,VU0_F06);	UPDATE_VU0_F(7,VU0_F07);	UPDATE_VU0_F(8,VU0_F08);
			UPDATE_VU0_F(9,VU0_F09);	UPDATE_VU0_F(10,VU0_F10);	UPDATE_VU0_F(11,VU0_F11);
			UPDATE_VU0_F(12,VU0_F12);	UPDATE_VU0_F(13,VU0_F13);	UPDATE_VU0_F(14,VU0_F14);
			UPDATE_VU0_F(15,VU0_F15);	UPDATE_VU0_F(16,VU0_F16);	UPDATE_VU0_F(17,VU0_F17);
			UPDATE_VU0_F(18,VU0_F18);	UPDATE_VU0_F(19,VU0_F19);	UPDATE_VU0_F(20,VU0_F20);
			UPDATE_VU0_F(21,VU0_F21);	UPDATE_VU0_F(22,VU0_F22);	UPDATE_VU0_F(23,VU0_F23);
			UPDATE_VU0_F(24,VU0_F24);	UPDATE_VU0_F(25,VU0_F25);	UPDATE_VU0_F(26,VU0_F26);
			UPDATE_VU0_F(27,VU0_F27);	UPDATE_VU0_F(28,VU0_F28);	UPDATE_VU0_F(29,VU0_F29);
			UPDATE_VU0_F(30,VU0_F30);	UPDATE_VU0_F(31,VU0_F31);


			UPDATE_VU0_I(0,VU0_VI00); 	UPDATE_VU0_I(1,VU0_VI01);	UPDATE_VU0_I(2,VU0_VI02);
			UPDATE_VU0_I(3,VU0_VI03);	UPDATE_VU0_I(4,VU0_VI04);	UPDATE_VU0_I(5,VU0_VI05);
			UPDATE_VU0_I(6,VU0_VI06);	UPDATE_VU0_I(7,VU0_VI07);	UPDATE_VU0_I(8,VU0_VI08);
			UPDATE_VU0_I(9,VU0_VI09);	UPDATE_VU0_I(10,VU0_VI10);	UPDATE_VU0_I(11,VU0_VI11);
			UPDATE_VU0_I(12,VU0_VI12);	UPDATE_VU0_I(13,VU0_VI13);	UPDATE_VU0_I(14,VU0_VI14);
			UPDATE_VU0_I(15,VU0_VI15);	UPDATE_VU0_I(16,VU0_VI16);	UPDATE_VU0_I(17,VU0_VI17);
			UPDATE_VU0_I(18,VU0_VI18);	UPDATE_VU0_I(19,VU0_VI19);	UPDATE_VU0_I(20,VU0_VI20);
			UPDATE_VU0_I(21,VU0_VI21);	UPDATE_VU0_I(22,VU0_VI22);	UPDATE_VU0_I(23,VU0_VI23);
			UPDATE_VU0_I(24,VU0_VI24);	UPDATE_VU0_I(25,VU0_VI25);	UPDATE_VU0_I(26,VU0_VI26);
			UPDATE_VU0_I(27,VU0_VI27);	UPDATE_VU0_I(28,VU0_VI28);	UPDATE_VU0_I(29,VU0_VI29);
			UPDATE_VU0_I(30,VU0_VI30);	UPDATE_VU0_I(31,VU0_VI31);


 	}


}



#define	UPDATE_VU1_F(REGID,EDITID)\
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->CPR_p_float[REGID][0]) ); \
 		Form_Debug->EDITID##_0->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->CPR_p_float[REGID][1]) ); \
 		Form_Debug->EDITID##_1->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->CPR_p_float[REGID][2]) ); \
 		Form_Debug->EDITID##_2->Text = TempText; \
		sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->CPR_p_float[REGID][3]) ); \
 		Form_Debug->EDITID##_3->Text = TempText \


#define	UPDATE_VU1_I(REGID,EDITID)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->VectorUnit1->CCR[REGID]);  \
 		Form_Debug->EDITID##->Text = TempText;


void	DBG_Update_VU1( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_VU1->Visible == TRUE ) {

			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->ACC_p_float[0]) );
 			Form_Debug->VU1_ACC_0->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->ACC_p_float[1]) );
 			Form_Debug->VU1_ACC_1->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->ACC_p_float[2]) );
 			Form_Debug->VU1_ACC_2->Text = TempText;
			sprintf(TempText,"%4.10f",(float)*(FromEmu->VectorUnit1->ACC_p_float[3]) );
 			Form_Debug->VU1_ACC_3->Text = TempText;

			UPDATE_VU1_F(0,VU1_F00);	UPDATE_VU1_F(1,VU1_F01);	UPDATE_VU1_F(2,VU1_F02);
			UPDATE_VU1_F(3,VU1_F03);	UPDATE_VU1_F(4,VU1_F04);	UPDATE_VU1_F(5,VU1_F05);
			UPDATE_VU1_F(6,VU1_F06);	UPDATE_VU1_F(7,VU1_F07);	UPDATE_VU1_F(8,VU1_F08);
			UPDATE_VU1_F(9,VU1_F09);	UPDATE_VU1_F(10,VU1_F10);	UPDATE_VU1_F(11,VU1_F11);
			UPDATE_VU1_F(12,VU1_F12);	UPDATE_VU1_F(13,VU1_F13);	UPDATE_VU1_F(14,VU1_F14);
			UPDATE_VU1_F(15,VU1_F15);	UPDATE_VU1_F(16,VU1_F16);	UPDATE_VU1_F(17,VU1_F17);
			UPDATE_VU1_F(18,VU1_F18);	UPDATE_VU1_F(19,VU1_F19);	UPDATE_VU1_F(20,VU1_F20);
			UPDATE_VU1_F(21,VU1_F21);	UPDATE_VU1_F(22,VU1_F22);	UPDATE_VU1_F(23,VU1_F23);
			UPDATE_VU1_F(24,VU1_F24);	UPDATE_VU1_F(25,VU1_F25);	UPDATE_VU1_F(26,VU1_F26);
			UPDATE_VU1_F(27,VU1_F27);	UPDATE_VU1_F(28,VU1_F28);	UPDATE_VU1_F(29,VU1_F29);
			UPDATE_VU1_F(30,VU1_F30);	UPDATE_VU1_F(31,VU1_F31);


			UPDATE_VU1_I(0,VU1_VI00); 	UPDATE_VU1_I(1,VU1_VI01);	UPDATE_VU1_I(2,VU1_VI02);
			UPDATE_VU1_I(3,VU1_VI03);	UPDATE_VU1_I(4,VU1_VI04);	UPDATE_VU1_I(5,VU1_VI05);
			UPDATE_VU1_I(6,VU1_VI06);	UPDATE_VU1_I(7,VU1_VI07);	UPDATE_VU1_I(8,VU1_VI08);
			UPDATE_VU1_I(9,VU1_VI09);	UPDATE_VU1_I(10,VU1_VI10);	UPDATE_VU1_I(11,VU1_VI11);
			UPDATE_VU1_I(12,VU1_VI12);	UPDATE_VU1_I(13,VU1_VI13);	UPDATE_VU1_I(14,VU1_VI14);
			UPDATE_VU1_I(15,VU1_VI15);	UPDATE_VU1_I(16,VU1_VI16);	UPDATE_VU1_I(17,VU1_VI17);
			UPDATE_VU1_I(18,VU1_VI18);	UPDATE_VU1_I(19,VU1_VI19);	UPDATE_VU1_I(20,VU1_VI20);
			UPDATE_VU1_I(21,VU1_VI21);	UPDATE_VU1_I(22,VU1_VI22);	UPDATE_VU1_I(23,VU1_VI23);
			UPDATE_VU1_I(24,VU1_VI24);	UPDATE_VU1_I(25,VU1_VI25);	UPDATE_VU1_I(26,VU1_VI26);
			UPDATE_VU1_I(27,VU1_VI27);	UPDATE_VU1_I(28,VU1_VI28);	UPDATE_VU1_I(29,VU1_VI29);
			UPDATE_VU1_I(30,VU1_VI30);	UPDATE_VU1_I(31,VU1_VI31);


 	}


}










#define	UPDATE_GIF(A,B)\
		sprintf(TempText,"%8.8lx",(_u32)FromEmu->GIF->Reg->A);\
 		Form_Debug->B->Text = TempText \

void	DBG_Update_GIF( ) {
 	char	TempText[1024];

	if ( Form_Debug->TabSheet_GIF->Visible == TRUE ) {
	    UPDATE_GIF(ctrl,Gif_CTRL);  	UPDATE_GIF(mode,Gif_MODE);
		UPDATE_GIF(stat,Gif_STAT);		UPDATE_GIF(tag0,Gif_TAG0);
		UPDATE_GIF(tag1,Gif_TAG1);		UPDATE_GIF(tag2,Gif_TAG2);
		UPDATE_GIF(tag3,Gif_TAG3);		UPDATE_GIF(cnt,Gif_CNT);
		UPDATE_GIF(p3cnt,Gif_P3CNT);	UPDATE_GIF(p3tag,Gif_P3TAG);


	}


}




void	DBG_UpdateDisasmOcpode( void ) {
	_u32 StartAdress;
	int boucle;
	int boucle2;

	BOOL	bFound_PC = false;


	if (  FromEmu == NULL ) return;


    StartAdress =  DBG_DisasmStartAdress - 8;
    MipsCpu_PC  =  StartAdress;


/* Clear the String Grid */
  int I, J;
  for (I = 0; I < Form_Debug->StringGrid1->ColCount; I++)
    for (J = 0; J < Form_Debug->StringGrid1->RowCount; J++)
      Form_Debug->StringGrid1->Cells[I][J] = "";


	for ( boucle = 1 ; boucle < 33 ; boucle ++ ) {


	if ( (( (_u32)StartAdress >= (_u32)0x1FC00000 ) && ( (_u32)StartAdress <= (_u32)0x1FFFFFFF )) ||
		 (( (_u32)StartAdress >= (_u32)0x9FC00000 ) && ( (_u32)StartAdress <= (_u32)0x9FFFFFFF )) ||
		 (( (_u32)StartAdress >= (_u32)0xBFC00000 ) && ( (_u32)StartAdress <= (_u32)0xBFFFFFFF ))
		)

 			MipsCpu_opcode = *( (_u32 *) (( _u8 *)( FromEmu->BiosMemory + ( (_u32)StartAdress & 0x3FFFFF)) ));

else
			MipsCpu_opcode = *( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)StartAdress & 0x01FFFFFF)) ));





// 		MipsCpu_opcode = *( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)StartAdress & 0x01FFFFFF)) ));

		if ( (_u32)MipsCpu_opcode == (_u32)0x0000000D ) {
			for ( boucle2 = 0 ; boucle2 < 256; boucle2++ ) {

                if ( Inspector_BP[ boucle2 ].Status == true ) {
					if ( Inspector_BP[ boucle2 ].Adress == StartAdress ) {
    	            	MipsCpu_opcode = Inspector_BP[ boucle2 ].Opcode;
						break;
					}
				}
			}
		}


		DisasmOpcode();

 		Form_Debug->StringGrid1->Cells[1][boucle] = IntToHex( (__int64)StartAdress ,8);
 		Form_Debug->StringGrid1->Cells[2][boucle] = debugTempText;
		Form_Debug->StringGrid1->Cells[3][boucle] = IntToHex( (__int64)MipsCpu_opcode ,8);



		/* Show "X" BreakPoint */
        for ( boucle2 = 0 ; boucle2 < 256 ; boucle2 ++ ) {
            if ( Inspector_BP[ boucle2 ].Status == true ) {
        		if ( Inspector_BP[ boucle2 ].Adress == StartAdress ) {
            		Form_Debug->StringGrid1->Cells[0][boucle] = "X";
					break;
				}
			}
		}

 		/* PC Selection */
		if ( (_u32)StartAdress ==  (_u32)FromEmu->MipsCpu->PC ) {

			bFound_PC = true;

  			TGridRect myRect;
  			myRect.Left = 0;
  			myRect.Top = boucle;
  			myRect.Right = 3;
  			myRect.Bottom = boucle ;
         	Form_Debug->StringGrid1->Selection = myRect;
            if ( Form_Debug->StringGrid1->Cells[0][boucle]  == "X" )
				Form_Debug->StringGrid1->Cells[0][boucle] = "X>";
			else
               	Form_Debug->StringGrid1->Cells[0][boucle] = ">";
 		}

		StartAdress = StartAdress + 4;
		MipsCpu_PC  = MipsCpu_PC + 4;
    }

	if ( bFound_PC == false ) {
  			TGridRect myRect;
  			myRect.Left = -1;
  			myRect.Top = -1;
  			myRect.Right = -1;
  			myRect.Bottom = -1 ;
         	Form_Debug->StringGrid1->Selection = myRect;



	}

}



#define MainMem_GetData(FPOS) *((( _u8 *)( fMem + ( (_u32)FPOS & (_u32)fMax)) ))


void	DBG_ShowMemoryAt( _u8 * fMem , _u32 fMax ,_u32	fPos ) {

	_u8		Data8;
    _u8		DataStr[512];

	_u32	DisplayPos;


 	int I, J;
  	for (I = 0; I < Form_Debug->StringGrid1->ColCount; I++)
    	for (J = 0; J < Form_Debug->StringGrid1->RowCount; J++)
      		Form_Debug->StringGrid_Memory->Cells[I][J] = "";


     DisplayPos = fPos;

	 for (J = 1; J < Form_Debug->StringGrid1->RowCount + 1; J++) {
		/* Adress */
 		Form_Debug->StringGrid_Memory->Cells[0][J] = IntToHex( (__int64) DisplayPos ,8);


		/* HExa */
 		Form_Debug->StringGrid_Memory->Cells[1][J] =
			IntToHex( (__int64) MainMem_GetData(DisplayPos+0) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+1) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+2) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+3) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+4) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+5) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+6) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+7) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+8) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+9) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+10) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+11) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+12) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+13) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+14) ,2) + " " +
			IntToHex( (__int64) MainMem_GetData(DisplayPos+15) ,2) + " " ;

     	/* String */

		memcpy ( DataStr, ((( _u8 *)( fMem + ( (_u32)DisplayPos & (_u32)fMax)) )), 16 );
        DataStr[16] = 0;
		for ( I = 0 ; I < 16 ; I++ ) {

			if ( DataStr[I] == 0 ) DataStr[I] = '.';

		}

		Form_Debug->StringGrid_Memory->Cells[2][J] = (char*)DataStr;


		DisplayPos = DisplayPos + 16;

     }



}

void	DBG_Update_Memory ( void ) {

	if ( Form_Debug->TabSheet_Memory->Visible == TRUE ) {

    	if ( Form_Debug->RadioButton_MemMain->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x01FFFFFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->MipsMemory , 0x01FFFFFF ,Form_Debug->ScrollBar_Memory->Position );

		}

    	if ( Form_Debug->RadioButton_MemSpecial->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x0000FFFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->SpecialAreaMemory , 0x0000FFFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemGS->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x00001FFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->GSAreaMemory , 0x00001FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemSPR->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x00003FFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->SPRMemory , 0x00003FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU0_Mem->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x00000FFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->VectorUnit0->Mem , 0x00000FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU0_Micro->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x00000FFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->VectorUnit0->MicroMem , 0x00000FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU1_Mem->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x00003FFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->VectorUnit1->Mem , 0x00003FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU1_Micro->Checked == true ) {

            Form_Debug->ScrollBar_Memory->Min = 0;
            Form_Debug->ScrollBar_Memory->Max = 0x00003FFF - ( 16 * Form_Debug->StringGrid1->RowCount );
            Form_Debug->ScrollBar_Memory->SmallChange = 16;
            Form_Debug->ScrollBar_Memory->LargeChange = 16;


        	DBG_ShowMemoryAt( FromEmu->VectorUnit1->MicroMem , 0x00003FFF ,Form_Debug->ScrollBar_Memory->Position );

		}


	}
}


void	DBG_MasterUpdate( void ) {

	if (  FromEmu == NULL ) return;

	if (  FromEmu->MipsCpu->InterpRunning == TRUE ) {

	 	DBG_UpdatePC();
	    DBG_Update_R5900( ) ;
	    DBG_Update_R5900_COP1( );
		DBG_Update_R5900_COP0();
        DBG_Update_DMAC( );
		DBG_Update_INTC();
		DBG_Update_TIMERS();
        DBG_Update_VIF( );
        DBG_Update_VU0( );
        DBG_Update_VU1( );
		DBG_Update_GIF( );
        DBG_UpdateDisasmOcpode();
        DBG_Update_Memory();



		Form_Debug->Refresh();



	}
}

//---------------------------------------------------------------------------
__fastcall TForm_Debug::TForm_Debug(TComponent* Owner)
	: TForm(Owner)
{
}

void __fastcall TForm_Debug::BitBtn1Click(TObject *Sender)
{
	Form_Debug->Hide();
}
//---------------------------------------------------------------------------


void __fastcall TForm_Debug::Image1Click(TObject *Sender)
{
	if ( FromEmu == NULL ) return;

	Bevel4->Style = bsLowered;
	Bevel6->Style = bsRaised;


	FromEmu->MipsCpu->halt = 0;

}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Image3Click(TObject *Sender)
{

	if ( FromEmu == NULL ) return;

    FromEmu->MipsCpu->halt = 1;

	Bevel6->Style = bsLowered;
	Bevel4->Style = bsRaised;
/*
	if ( Form_Debug->RadioButton_PC->Checked == TRUE )

	else
        DBG_DisasmStartAdress = 0;
*/

	Timer1->Enabled = true;


}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Image2Click(TObject *Sender)
{
	if ( FromEmu == NULL ) return;

	FromEmu->MipsCpu->halt = 2;

	Timer1->Enabled = true;

	Form_Debug->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::PageControl1Change(TObject *Sender)
{
	DBG_MasterUpdate( );
}


//---------------------------------------------------------------------------

char DebugCurrentDir[1024];

void __fastcall TForm_Debug::FormCreate(TObject *Sender)
{
	Form_Debug->Caption = "nSX2 Inspector " + IntToStr( DEBUG_VERSION ) + "." + IntToStr( DEBUG_BUILD );
    DBG_DisasmStartAdress = 0;
	FromEmu = NULL;

	GetCurrentDirectory( 1024, DebugCurrentDir );

	DBG_BP_Init();

}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::FormShow(TObject *Sender)
{
	Form_Debug->Caption = "nSX2 Inspector " + IntToStr( DEBUG_VERSION ) + "." + IntToStr( DEBUG_BUILD );

	Form_Debug->StringGrid1->Cells[1][0] = "Adress";
	Form_Debug->StringGrid1->Cells[2][0] = "Opcode";
	Form_Debug->StringGrid1->Cells[3][0] = "Binary";


	if (  FromEmu != NULL ) {

		if ( FromEmu->MipsCpu->halt == 1 ) {

			Bevel6->Style = bsLowered;
			Bevel4->Style = bsRaised;

	        DBG_DisasmStartAdress = FromEmu->MipsCpu->PC;
		    DBG_MasterUpdate();
		}  else {
			Bevel4->Style = bsLowered;
			Bevel6->Style = bsRaised;
 		}

	}

}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_PCClick(TObject *Sender)
{
	if (  FromEmu == NULL ) return;

	DBG_DisasmStartAdress = FromEmu->MipsCpu->PC;
    DBG_UpdateDisasmOcpode( );
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MANUALClick(TObject *Sender)
{
    int i1;
	char TempString[512];

	if (  FromEmu == NULL ) return;


	strcpy( TempString, "0x");
	strcat( TempString, Edit_JUMP_TO->Text.c_str());
    DBG_DisasmStartAdress = StrToInt(TempString);

    DBG_UpdateDisasmOcpode( );



}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MANUALMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int i1;
	char TempString[512];

	if (  FromEmu == NULL ) return;

	strcpy( TempString, "0x");
	strcat( TempString, Edit_JUMP_TO->Text.c_str());
    DBG_DisasmStartAdress = StrToInt(TempString);

    DBG_UpdateDisasmOcpode( );

}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Image2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Bevel5->Style = bsLowered;
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Image2MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    Bevel5->Style = bsRaised;
}
//---------------------------------------------------------------------------


BOOL	UP_IS_PRESSED = false;

void __fastcall TForm_Debug::Button_DISASM_UPMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
       if (  FromEmu == NULL ) return;

        UP_IS_PRESSED = true;

		while (  UP_IS_PRESSED == true ) {

			DBG_DisasmStartAdress = DBG_DisasmStartAdress - 4;
    		DBG_UpdateDisasmOcpode( );
            Application->HandleMessage();
 		}



}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Button_DISASM_UPMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
     UP_IS_PRESSED = false;
}
//---------------------------------------------------------------------------

BOOL	DOWN_IS_PRESSED = false;


void __fastcall TForm_Debug::Button_DISASM_DOWNMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
       if (  FromEmu == NULL ) return;

        DOWN_IS_PRESSED = true;

		while (  DOWN_IS_PRESSED == true ) {

			DBG_DisasmStartAdress = DBG_DisasmStartAdress + 4;
    		DBG_UpdateDisasmOcpode( );
            Application->HandleMessage();
 		}


}
//---------------------------------------------------------------------------


void __fastcall TForm_Debug::Button_DISASM_DOWNMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
     DOWN_IS_PRESSED = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Timer1Timer(TObject *Sender)
{
	int boucle;


    DBG_DisasmStartAdress =  FromEmu->MipsCpu->PC;
	DBG_MasterUpdate(  );

	for ( boucle = 0 ; boucle < 256 ; boucle++ ) {

    	if ( Inspector_BP[ boucle ].Status == true ) {
 		/*Change Memory HERE */
        *( (_u32 *) (( _u8 *)( FromEmu->MipsMemory + ( (_u32)Inspector_BP[ boucle ].Adress & 0x01FFFFFF)) )) = 0x0000000D;
 		}
	}



	Timer1->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::StringGrid1SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
    _u32	BP_Add;
	char TempString[512];
	int boucle;
	BOOL BP_found = false;

	if (  FromEmu == NULL ) return;

	strcpy( TempString, "0x");
	strcat( TempString, Form_Debug->StringGrid1->Cells[1][ARow].c_str());
    BP_Add = StrToInt(TempString);


	for ( boucle = 0 ; boucle < 256 ; boucle ++ ) {

    	if ( (_u32)BP_Add == (_u32)Inspector_BP[ boucle ].Adress ) {
        	BP_found = true;
            DBG_BP_Remove_BreakPoint ( BP_Add );

            break;
		}

	}

	if ( BP_found == false )
	    DBG_BP_Add_BreakPoint ( BP_Add );


	 CanSelect = false;

    DBG_UpdateDisasmOcpode( );



}
//---------------------------------------------------------------------------



void __fastcall TForm_Debug::ScrollBar_MemoryChange(TObject *Sender)
{

	if (  FromEmu == NULL ) return;

    	if ( Form_Debug->RadioButton_MemMain->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->MipsMemory , 0x01FFFFFF ,Form_Debug->ScrollBar_Memory->Position );

		}

    	if ( Form_Debug->RadioButton_MemSpecial->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->SpecialAreaMemory , 0x0000FFFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemGS->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->GSAreaMemory , 0x00001FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemSPR->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->SPRMemory , 0x00003FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU0_Mem->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->VectorUnit0->Mem , 0x00000FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU0_Micro->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->VectorUnit0->MicroMem , 0x00000FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU1_Mem->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->VectorUnit1->Mem , 0x00003FFF ,Form_Debug->ScrollBar_Memory->Position );

		}

   	if ( Form_Debug->RadioButton_MemVU1_Micro->Checked == true ) {
        	DBG_ShowMemoryAt( FromEmu->VectorUnit1->MicroMem , 0x00003FFF ,Form_Debug->ScrollBar_Memory->Position );

		}



}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Mem_DirectAcceChange(TObject *Sender)
{
    _u32	DA_Add;
	char TempString[512];


	strcpy( TempString, "0x");
	strcat( TempString, Form_Debug->Mem_DirectAcce->Text.c_str());
    DA_Add = StrToInt(TempString);

    Form_Debug->ScrollBar_Memory->Position = DA_Add;



}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemMainClick(TObject *Sender)
{
	DBG_Update_Memory (  );
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemSpecialClick(TObject *Sender)
{
	DBG_Update_Memory (  );	
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemGSClick(TObject *Sender)
{
	DBG_Update_Memory (  );		
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemSPRClick(TObject *Sender)
{
	DBG_Update_Memory (  );		
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemVU0_MemClick(TObject *Sender)
{
	DBG_Update_Memory (  );		
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemVU0_MicroClick(TObject *Sender)
{
	DBG_Update_Memory (  );		
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemVU1_MemClick(TObject *Sender)
{
	DBG_Update_Memory (  );		
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::RadioButton_MemVU1_MicroClick(TObject *Sender)
{
	DBG_Update_Memory (  );		
}
//---------------------------------------------------------------------------
/*******************************************************************/

FILE * DebugAsmFile;





void __fastcall TForm_Debug::BitBtn3Click(TObject *Sender)
{
	char szFileName[1024+4];
	int iFileHandle;
	int iLength;


	char ASM5900_DIR[1024];

	_u32	Add;
	_u32	Opcode;
	BOOL	FindFirstAdd = false;
	char c;

    int boucle,boucle2;
	AnsiString *st_Line;
	AnsiString *st_Adrr;
	AnsiString *st_Opcode;


	if (  FromEmu == NULL ) return;

	sprintf(ASM5900_DIR,"%s\\plugins\\_Inspector\\",DebugCurrentDir);

	SetCurrentDir(ASM5900_DIR);

    /*1: Save to File */
	Memo1->Lines->SaveToFile("debug.asm");

	/*2:Compile using Wire Asm */
 	system("asm5900 debug.asm -o:debug.elf -t:BIN > asm5900.txt");

    /*3:Display the Log */
    Memo2->Lines->LoadFromFile("asm5900.txt");


    ElfOpenFile("debug.elf");
  	ElfLoadHeader();		/*Read the header of the Elf File*/
	CopyProgramToMemory() ;	/*Copy the program to memory according the elf header*/
	CopySectionToMemory( );	/*Copy data to memory according the elf header*/
	ElfFreeHeader();
    ElfCloseFile();

    DBG_DisasmStartAdress = FromEmu->MipsCpu->PC;
	DBG_MasterUpdate();



    DeleteFile("debug.asm");
	DeleteFile("debug.elf");
	DeleteFile("asm5900.txt");

	SetCurrentDir(DebugCurrentDir);

}
//---------------------------------------------------------------------------


void __fastcall TForm_Debug::Button22Click(TObject *Sender)
{
	Memo1->Clear();
	Memo1->Lines->LoadFromFile(".\\plugins\\_Inspector\\template.asm");


}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Button1Click(TObject *Sender)
{

	if (OpenDialog1->Execute())
	{
    	Memo1->Lines->LoadFromFile ( OpenDialog1->FileName ) ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm_Debug::Button2Click(TObject *Sender)
{


	if (SaveDialog1->Execute())
	{
    	Memo1->Lines->SaveToFile( SaveDialog1->FileName ) ;
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm_Debug::BitBtn2Click(TObject *Sender)
{
	Form_About->Visible = true;

}
//---------------------------------------------------------------------------

