//---------------------------------------------------------------------------

#ifndef DcmpH
#define DcmpH

/*
 * dcmp
 */

typedef struct _DCMPHEAD{
    unsigned char type;
    unsigned char code;
    unsigned short unused;
} DCMPHEAD;

#define DCMPHEAD_SZ	sizeof(DCMPHEAD)

#define DCMP_TYPE_CONNECT	0
#define DCMP_TYPE_ECHO		1
#define DCMP_TYPE_STATUS	2
#define DCMP_TYPE_ERROR		3

typedef struct {
    unsigned char result;
} DCMP_CONNECT;

#define DCMP_CONNECT_SZ	sizeof(DCMP_CONNECT);

/* code for DCMP_TYPE_CONNECT */
#define DCMP_CODE_CONNECT	0
#define DCMP_CODE_CONNECTR	1
#define DCMP_CODE_DISCONNECT	2
#define DCMP_CODE_DISCONNECTR	3

/* result for DCMP_TYPE_CONNECT */
#define DCMP_ERR_INVALDEST	1  /* destination invalid */
#define DCMP_ERR_ALREADYCONN	2  /* already connected   */
#define DCMP_ERR_NOTCONNECT	3  /* not connected       */

typedef struct {
    unsigned short identifier;
    unsigned short sequence_number;
} DCMP_ECHO;

#define DCMP_ECHO_SZ	sizeof(DCMP_ECHO)

/* code for DCMP_TYPE_ECHO */
#define DCMPC_ECHO	0
#define DCMPC_ECHOR	1

typedef struct _DCMP_STATUS{
    unsigned short protocol;
} DCMP_STATUS;

#define DCMP_STATUS_SZ	sizeof(DCMP_STATUS)

/* code for DCMP_TYPE_STATUS */
#define DCMP_CODE_CONNECTED	0  /* !NOCONNECT */
#define DCMP_CODE_PROTO		1  /* !NOPROTO   */
#define DCMP_CODE_UNLOCKED	2  /* !LOCKED    */
#define DCMP_CODE_SPACE		3  /* !NOSPACE   */
#define DCMP_CODE_ROUTE		4  /* !NOROUTE   */
/*
typedef struct {
    DECI2HEAD org_hdr;
    unsigned int word0;
    unsigned int word1;
    unsigned int word2;
    unsigned int word3;
} DCMP_ERROR;

#define DCMP_ERROR_SZ	sizeof(DCMP_ERROR)
*/
/* code for DCMP_TYPE_ERROR */
#define DCMP_CODE_NOROUTE	0  /* no route to node                 */
#define DCMP_CODE_NOPROTO	1  /* protocol unreachable             */
#define DCMP_CODE_LOCKED	2  /* locked                           */
#define DCMP_CODE_NOSPACE	3  /* deci2 manager/dsnetm buffer full */
#define DCMP_CODE_INVALHEAD	4  /* invalid header                   */
#define DCMP_CODE_NOCONNECT	5  /* not connected                    */


typedef struct _DCMPCONNECT{
    unsigned char type;
    unsigned char code;
    unsigned short unused;
    unsigned char result;
    unsigned char pad0;
    unsigned short pad1;
    __int64  EEboot;
    __int64  IOPboot;
} DCMPCONNECT;

#define DCMPHEAD_SZ	sizeof(DCMPHEAD)

#define		DCMP_LOG(A)	MainWindow->Memo->Lines->Add("[DCMP]" A)



void SendPacket_DcmpReset(char dest, char src, char code, short node) ;

//---------------------------------------------------------------------------
#endif
