//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#include <stdlib.h>

#include "FormMainwindow.h"


#include "../nsx2.h"
#include "../_Debuger/debuger.h"

#include "Dbgp.h"

#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
        return 1;
}
//---------------------------------------------------------------------------


pluginDebuger *FromEmu = NULL;
int 	DebugWindowCreated = FALSE;


void
HelloWorld () {    MessageBox (0, "Hello World from DLL!\n", "Hi", MB_ICONINFORMATION); }

#define PS2E_LT_DBG  0x12

const unsigned char version  = 0;
const unsigned char revision = 0;
const unsigned char build    = 1;
   
static char *libraryName     = "Debugger RDebug";

EXPORT(_u32)	PS2EgetLibType()		{	return PS2E_LT_DBG;	}

EXPORT(char*) PS2EgetLibName(void)   	{	return libraryName;	}

EXPORT(_u32)	PS2EgetLibVersion()	{	return version<<16|revision<<8|build;	}

EXPORT(int) DLL_OpenDebuger ( HINSTANCE hINST ) {

		if ( DebugWindowCreated == FALSE ) {

	        MainWindow = new TMainWindow(NULL);
            DebugWindowCreated = TRUE;
        }
     FromEmu = NULL;

	return TRUE;


}

EXPORT(int) DLL_CloseDebuger ( HINSTANCE hINST ) {

	if ( DebugWindowCreated == TRUE ) {
        delete MainWindow;

        DebugWindowCreated = FALSE;

    }
     FromEmu = NULL;
	return TRUE;


}



EXPORT(int) DLL_InitDebuger ( pluginDebuger *fPlugin ) {

	FromEmu = fPlugin;

	return TRUE;
}

EXPORT(int) DLL_ShutdownDebuger ( void ) {

	FromEmu = NULL;

	return TRUE;
}



EXPORT(void) DLL_ShowHideDebuger (HWND hwnd ) {

		if ( DebugWindowCreated == TRUE ) {

        if ( MainWindow->Visible == TRUE ) MainWindow->Hide();
        else        MainWindow->Show();

        }
}


EXPORT(void) DLL_SendBreak ( ) {

    SendPacket_Dbgp_Breaked();


}



/*****************************************************************************************/






void	WriteToMemory( int space, int align,  __int32 adress,  __int32 size, int VUID, char * Src ) {
    char	*MemDest;
    int     DataSize;

	__int64		val64 = 0;

	switch ( space ) {
       	case DBGP_SPACE_MAIN_MEMORY:

			if ( (( (_u32)adress >= (_u32)0x70000000 ) && ( (_u32)adress <= (_u32)0x70003FFF ))	)	{
        		MemDest =  FromEmu->SPRMemory  +  ( (_u32)adress  & 0x3FFF );
			} else {
				if ( ( (_u32)adress >= 0x10000000 ) && ( (_u32)adress <= 0x1000FFFF ) ){
					MemDest =  FromEmu->SpecialAreaMemory + (  adress  & 0xFFFF );
				} else {
					if ( ( (_u32)adress >= 0x12000000 ) && ( (_u32)adress <= 0x12001080 ) ){
						MemDest =  FromEmu->GSAreaMemory  + (  adress  & 0x1FFF );
					} else {
                			MemDest =  FromEmu->MipsMemory + ( adress  &	0x01FFFFFF );

            		}
        		}
       		}

        break;

       	case DBGP_SPACE_VU_MEM:
          	if ( VUID == DBGP_CPUID_VU0 ) MemDest = FromEmu->VectorUnit0->Mem + ( adress  &	0x0FFF );
            else MemDest = FromEmu->VectorUnit1->Mem + ( adress  &	0x3FFF );
        break;

      	case DBGP_SPACE_VU_UMEM:
          	if ( VUID == DBGP_CPUID_VU0 ) MemDest = FromEmu->VectorUnit0->MicroMem + ( adress  &	0x0FFF );
            else MemDest = FromEmu->VectorUnit1->MicroMem + ( adress  &	0x3FFF );
        break;
	}

    memcpy(MemDest, Src, sizeof(char) * size );

 /*
	if ( align == 2 ) {
		if ( size < 8 ) {
			memcpy(&val64, Src, sizeof(char) * size );

			DBGP_Log("Value = %8.8lx",val64);
		}
    }
  */
}


int ReadFromMemory( int space, int align,  __int32 adress,  __int32 size, int VUID, char * Dst ) {
    char	*MemSrc;
    int     DataSize;

 	__int64		val64 = 0;
	switch ( space ) {
       	case DBGP_SPACE_MAIN_MEMORY:

			if ( (( adress >= 0x70000000 ) && ( adress <= 0x70003FFF ))	)	{
        		MemSrc =  FromEmu->SPRMemory  + ( adress & 0xFFFF );
			} else {
				if ( ( adress >= 0x10000000 ) && ( adress <= 0x1000FFFF ) ){
					MemSrc =  FromEmu->SpecialAreaMemory  + ( adress & 0xFFFF );
				} else {
					if ( ( adress >= 0x12000000 ) && ( adress <= 0x12001080 ) ){
						MemSrc =  FromEmu->GSAreaMemory + ( adress & 0xFFFF );
					} else {
					  			MemSrc = FromEmu->MipsMemory + ( adress  &	0x01FFFFFF );
                 		}
            		}
        		}


        break;
       	case DBGP_SPACE_VU_MEM:
          	if ( VUID == DBGP_CPUID_VU0 ) MemSrc = FromEmu->VectorUnit0->Mem + ( adress  &	0x0FFF );
            else MemSrc = FromEmu->VectorUnit1->Mem + ( adress  &	0x3FFF );
        break;
      	case DBGP_SPACE_VU_UMEM:
          	if ( VUID == DBGP_CPUID_VU0 ) MemSrc = FromEmu->VectorUnit0->MicroMem + ( adress  &	0x0FFF );
            else MemSrc = FromEmu->VectorUnit1->MicroMem + ( adress  &	0x3FFF );
        break;
	}


    memcpy(Dst, MemSrc, sizeof(char) * size);
/*
	if ( align == 2 ) {
		if ( size < 8 ) {
			memcpy(&val64, MemSrc, sizeof(char) * size );

			DBGP_Log("Value = %8.8lx",val64);
		}
	}
*/

    return ( sizeof(char) * size );
}


