/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Rpc_services.h"

static int mtype=1;//SCECdCD

/////////////////////////////////////////////// 0001
void cdvdfsv3_sceCdReadClock(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdReadClock()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0002
void cdvdfsv3_sceCdWriteClock(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdWriteClock()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0003
void cdvdfsv3_sceCdGetDiskType(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	*bout=mtype==SCECdCD ? SCECdPS2CD : SCECdPS2DVD;
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdGetDiskType() => %x\n", *bout);
#endif
}

/////////////////////////////////////////////// 0004
void cdvdfsv3_sceCdGetError(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdGetError()\n");
#endif
	*bout=0;//SCECdErNO
}

/////////////////////////////////////////////// 0005
void cdvdfsv3_sceCdTrayReq(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	static int open=FALSE, trayopenned=FALSE;

#ifdef RPC_LOG
	RPC_LOG("[RPC:cdvdfsv3] sceCdTrayReq(mode=%d, &traycnt)", bin[0]);
#endif
	switch (bin[0]){
	case 0:
		open=TRUE;
		trayopenned=TRUE;
#ifdef RPC_LOG
		RPC_LOG(" open tray\n");
#endif
		break;
	case 1:
		open=FALSE;
#ifdef RPC_LOG
		RPC_LOG(" close tray\n");
#endif
		break;
	case 2:
#ifdef RPC_LOG
		RPC_LOG(" get tray state change: %s\n", trayopenned ? "Performed an open":"Not performing an open");
#endif
		bout[1]=trayopenned;
		trayopenned=FALSE;//reset state change
	}
	*bout=1;//success; hm, should we open the tray in the plugin too? multi-cd/dvd games...
}

/////////////////////////////////////////////// 0006
void cdvdfsv3__sceCdRI(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] _sceCdRI()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0007
void cdvdfsv3_sceCdWriteILinkID(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdWriteILinkID()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0008
void cdvdfsv3_readNVM(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] readNVM()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0009
void cdvdfsv3_writeNVM(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] writeNVM()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 000A
void cdvdfsv3_DEC_SET(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] DEC_SET(%08x)\n", bin[0]);
#endif
	*bout=0;//1
}

/////////////////////////////////////////////// 000B
void cdvdfsv3_DEC_SETS(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] DEC_SETS()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 000C
void cdvdfsv3_sceCdStatus(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdStatus()\n");
#endif
//SCECdStatShellOpen Tray is OPEN	SCECdStatShellOpen      0x01    /* once shell open        */
//SCECdStatStop Stopped				SCECdStatStop           0x00    /* Stop                   */
//SCECdStatSpin Spindle is spinning	SCECdStatSpin           0x02    /* spindle motor rotating */
//SCECdStatRead Reading				SCECdStatRead           0x06    /* reading data sectors   */
//SCECdStatPause Paused (unreferenced)SCECdStatPause          0x0a    /* pause                  */
//SCECdStatSeek Seeking				SCECdStatSeek           0x12    /* seeking                */
//SCECdStatEmg Abnormal termination	SCECdStatEmg            0x20    /* error detected         */
	*bout=0xa;
}

/////////////////////////////////////////////// 000D
void cdvdfsv3_setHDMode(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] setHDMode()\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 000E
void cdvdfsv3_sceCdOpenConfig(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3;%X] sceCdOpenConfig(a=%d, b=%d, count=%d, 0x%X)\n", call->send_size,
				(bin[0]>>8) & 0xFF,	bin[0] & 0xFF, (bin[0]>>16) & 0xFF, bout+1);
#endif
	*bout=1;
}

/////////////////////////////////////////////// 000F
void cdvdfsv3_sceCdCloseConfig(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3;%X] sceCdCloseConfig()\n", call->send_size);
#endif
	*bout=1;
}

/////////////////////////////////////////////// 0010
void cdvdfsv3_sceCdReadConfig(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3;%X] sceCdReadConfig()\n", call->send_size);
#endif
	*bout=1;
}

/////////////////////////////////////////////// 0011
void cdvdfsv3_sceCdWriteConfig(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdWriteConfig() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0012
void cdvdfsv3_ReadConsole(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] ReadConsole() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0013
void cdvdfsv3_WriteConsoleID(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] WriteConsoleID() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0014
void cdvdfsv3_GetMecacon(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] GetMecacon() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0015
void cdvdfsv3_CtrlAudioDigitalOut(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] CtrlAudioDigitalOut() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0016
void cdvdfsv3_sceCdBreak(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdBreak() DUMMY\n");
#endif
	*bout=1;//breaking command succeded
}

/////////////////////////////////////////////// 0017
void cdvdfsv3_ReadSUBQ(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] ReadSUBQ() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0018
void cdvdfsv3_ForbidDVDP(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] ForbidDVDP() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0019
void cdvdfsv3_AutoAdjustCtrl(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] AutoAdjustCtrl() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 001A
void cdvdfsv3__sceCdRM(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] _sceCdRM() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 001B
void cdvdfsv3__sceCdWM(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] _sceCdWM() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0021
void cdvdfsv3_sceCdPowerOff(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdPowerOff() DUMMY\n");
#endif
	*bout=0;
}

/////////////////////////////////////////////// 0022
void cdvdfsv3_sceCdMmode(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
	RPC_LOG("[RPC:cdvdfsv3] sceCdMmode(%s)\n", bin[0]==SCECdCD?"SCECdCD":"SCECdDVD");
#endif
	*bout=1;//success
	mtype=bin[0];
}

/////////////////////////////////////////////// 0023
void cdvdfsv3_sceCdChangeThreadPriority(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
#ifdef RPC_LOG
			RPC_LOG("[RPC:cdvdfsv3] sceCdChangeThreadPriority() DUMMY\n");
#endif
	*bout=0;
}

//ENTRYPOINT
void sifcall_cdvdfsv3(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	switch (call->rpc_number){
	case CDVD_READCLOCK:	cdvdfsv3_sceCdReadClock(call, bin, bout);		break;
	case CDVD_WRITECLOCK:	cdvdfsv3_sceCdWriteClock(call, bin, bout);		break;
	case CDVD_GETDISKTYPE: 	cdvdfsv3_sceCdGetDiskType(call, bin, bout);		break;
	case CDVD_GETERROR:		cdvdfsv3_sceCdGetError(call, bin, bout);		break;
	case CDVD_TRAYREQ:		cdvdfsv3_sceCdTrayReq(call, bin, bout);			break;
	case CDVD_READILINK:	cdvdfsv3__sceCdRI(call, bin, bout);				break;
	case CDVD_WRITEILINK:	cdvdfsv3_sceCdWriteILinkID(call, bin, bout);	break;
	case CDVD_READNVM:		cdvdfsv3_readNVM(call, bin, bout);				break;
	case CDVD_WRITENVM:		cdvdfsv3_writeNVM(call, bin, bout);				break;
	case CDVD_DECSET:		cdvdfsv3_DEC_SET(call, bin, bout);				break;
	case CDVD_DECSETS:		cdvdfsv3_DEC_SETS(call, bin, bout);				break;
	case CDVD_STATUS:		cdvdfsv3_sceCdStatus(call, bin, bout);			break;
	case CDVD_HDMODE:		cdvdfsv3_setHDMode(call, bin, bout);			break;
	case CDVD_OPENCONFIG:	cdvdfsv3_sceCdOpenConfig(call, bin, bout);		break;
	case CDVD_CLOSECONFIG: 	cdvdfsv3_sceCdCloseConfig(call, bin, bout);		break;
	case CDVD_READCONFIG:	cdvdfsv3_sceCdReadConfig(call, bin, bout);		break;
	case CDVD_WRITECONFIG: 	cdvdfsv3_sceCdWriteConfig(call, bin, bout);		break;
	case CDVD_READCONSOLE: 	cdvdfsv3_ReadConsole(call, bin, bout);			break;
	case CDVD_WRITECONSOLE:	cdvdfsv3_WriteConsoleID(call, bin, bout);		break;
	case CDVD_GETMECACON:	cdvdfsv3_GetMecacon(call, bin, bout);			break;
	case CDVD_CTRLAUDDIGOUT:cdvdfsv3_CtrlAudioDigitalOut(call, bin, bout);	break;
	case CDVD_BREAK:		cdvdfsv3_sceCdBreak(call, bin, bout);			break;
	case CDVD_READSUBQ:		cdvdfsv3_ReadSUBQ(call, bin, bout);				break;
	case CDVD_FORBIDDVDP:	cdvdfsv3_ForbidDVDP(call, bin, bout);			break;
	case CDVD_AUTOADJUST:	cdvdfsv3_AutoAdjustCtrl(call, bin, bout);		break;
	case CDVD_RM:			cdvdfsv3__sceCdRM(call, bin, bout);				break;
	case CDVD_WM:			cdvdfsv3__sceCdWM(call, bin, bout);				break;
	case CDVD_POWEROFF:		cdvdfsv3_sceCdPowerOff(call, bin, bout);		break;
	case CDVD_MMODE:		cdvdfsv3_sceCdMmode(call, bin, bout);			break;
	case CDVD_CHANGETHREADPRIO:
					cdvdfsv3_sceCdChangeThreadPriority(call, bin, bout);	break;
	default:
#ifdef RPC_LOG
		RPC_LOG("[RPC:cdvdfsv3] <%04X> function is not implemented\n", call->rpc_number);
#endif
		*bout=0;	//failure
	}
}