#include "Common.h"
#include "Sifcmd.h"

#define BIOS_LOG RPC_LOG

void sifcall_fake(struct t_sif_rpc_call* call, u32* bin, u32* bout)
{
	switch (call->rpc_number) 
	{
		case 0xff: // init? returns version
			*bout = *(int*)RPCVER;
			break;

		default:
			*bout = 1;
			break;
	}
}

char datafile_name[255];

void sifcall_module(struct t_sif_rpc_call* call, u32* bin, u32* bout)
{
	char *fdesc, *str;
	char fserv[256], fname[256];
	char file[256];
	char RPCVersion[5];
	int i;

	switch (call->rpc_number) 
	{
		case 0: // sceSifLoadModule (.irx)
			fdesc = (char *)&bin[2];

			if (strstr(fdesc, "SJDATA.IRX")){//SJDATA driver?
				strcpy(datafile_name, (char*)&bin[65] + strlen("cdromN:")); //then search for the filesystem file
				datafile_name[255]=0;
			}

			SysPrintf("loadModule %s\n", fdesc);

			i=0;
			while (*fdesc != ':' && *fdesc != 0) fserv[i++] = *fdesc++; fserv[i] = 0;
			i=0; fdesc++;
			while (*fdesc != 0) {
#if defined (__LINUX__)
				if (*fdesc == '\\') {
					fdesc++;
					if (i != 0) fname[i++] = '/';
				} else
#endif
				fname[i++] = *fdesc++;
			}
			fname[i] = 0;

			bout[0] = 0;

			if (strncmp(fserv, "host", 4) == 0) {
#ifdef __WIN32__
				sprintf(file, "host\\%s", fname);
#else
				sprintf(file, "host/%s", fname);
#endif
				SysPrintf("opening %s\n", file);

//				loadIrxFile(file);
			}

			if (strncmp(fserv, "cdrom", 5) == 0) {
#ifdef __WIN32__
				sprintf(file, "host\\%s", fname);
#else
				sprintf(file, "host/%s", fname);
#endif
				file[strlen(file) - 2] = 0;
				SysPrintf("opening %s\n", file);

//				loadIrxFile(file);
			}
			break;

		case 0x01: // sceSifLoadElfPart
			str = (char *)&bin[2];
			SysPrintf("sceSifLoadElfPart: %s, %s\n", str, (char *)&bin[65]);
			bout[0] = 1;
			break;

		case 0x06: //sceSifLoadModuleBuffer
			SysPrintf("sceSifLoadModuleBuffer: %X, %d\n", bin[0], call->send_size);
			bout[0] = 1;
			break;

		case 0xff: // init? returns version
			memcpy(RPCVersion,RPCVER,4);
			RPCVersion[4] = 0;
			SysPrintf("[RPC:loadfile] moduleVersion=%s\n", RPCVersion);
			*bout = *(int*)RPCVER;
			break;

		default:
			SysPrintf("module unk: %x\n", call->rpc_number);
			break;
	}
}


/* from padlib 1.2 */

/* pad.h */

/*
 * Pad states
 */
#define PAD_STATE_DISCONN     	0x00
#define PAD_STATE_FINDPAD       0x01
#define PAD_STATE_FINDCTP1      0x02
#define PAD_STATE_EXECCMD       0x05
#define PAD_STATE_STABLE        0x06
#define PAD_STATE_ERROR      	0x07

/*
 * Pad request states
 */
#define PAD_RSTAT_COMPLETE      0x00
#define PAD_RSTAT_FAILED        0x01
#define PAD_RSTAT_BUSY          0x02

/*
 * Button info
 */
struct padButtonStatus
{
    unsigned char ok;
    unsigned char mode;
    unsigned char btns[2];
    // joysticks
    unsigned char rjoy_h;
    unsigned char rjoy_v;
    unsigned char ljoy_h;
    unsigned char ljoy_v;
    // pressure mode
    unsigned char left_p;
    unsigned char rigth_p;
    unsigned char up_p;
    unsigned char down_p;
    unsigned char triangle_p;
    unsigned char circle_p;
    unsigned char square_p;
    unsigned char cross_p;
    unsigned char unkn16[16];
};

/* end of pad.h */

/* pad.c */

/*
 * Defines
 */
/* rom0:padman */
#define PAD_BIND_RPC_ID1 0x8000010f
#define PAD_BIND_RPC_ID2 0x8000011f

#define PAD_RPCCMD_OPEN         0x80000100
#define PAD_RPCCMD_SET_MMODE    0x80000105
#define PAD_RPCCMD_SET_ACTDIR   0x80000106
#define PAD_RPCCMD_SET_ACTALIGN 0x80000107
#define PAD_RPCCMD_GET_BTNMASK  0x80000108
#define PAD_RPCCMD_SET_BTNINFO  0x80000109
#define PAD_RPCCMD_SET_VREF     0x8000010a
#define PAD_RPCCMD_GET_PORTMAX  0x8000010b
#define PAD_RPCCMD_GET_SLOTMAX  0x8000010c
#define PAD_RPCCMD_CLOSE        0x8000010d
#define PAD_RPCCMD_END          0x8000010e

#define PAD_RPCCMD_INIT         0x00000000  /* not supported */
#define PAD_RPCCMD_GET_CONNECT  0x00000000  /* not supported */
#define PAD_RPCCMD_GET_MODVER   0x00000000  /* not supported */

struct pad_state
{
    int open;
    unsigned int port;
    unsigned int slot;
    struct pad_data *padData;
    unsigned char *padBuf;
};

struct pad_data 
{
    unsigned int frame;
    unsigned char state;
    unsigned char reqState;
    unsigned char ok;
    unsigned char unkn7;
    unsigned char data[32];
    unsigned int length;
    unsigned int unkn44;
    unsigned int unkn48;
    unsigned int unkn52;
    unsigned int unkn54;
    unsigned int unkn60;
};

/* rom0:xpadman */
#define XPAD_BIND_RPC_ID1 0x80000100
#define XPAD_BIND_RPC_ID2 0x80000101

#define XPAD_RPCCMD_OPEN         0x01
#define XPAD_RPCCMD_SET_MMODE    0x06
#define XPAD_RPCCMD_SET_ACTDIR   0x07
#define XPAD_RPCCMD_SET_ACTALIGN 0x08
#define XPAD_RPCCMD_GET_BTNMASK  0x09
#define XPAD_RPCCMD_SET_BTNINFO  0x0A
#define XPAD_RPCCMD_SET_VREF     0x0B
#define XPAD_RPCCMD_GET_PORTMAX  0x0C
#define XPAD_RPCCMD_GET_SLOTMAX  0x0D
#define XPAD_RPCCMD_CLOSE        0x0E
#define XPAD_RPCCMD_END          0x0F
#define XPAD_RPCCMD_INIT         0x10
#define XPAD_RPCCMD_GET_CONNECT  0x11
#define XPAD_RPCCMD_GET_MODVER   0x12

struct xpad_data 
{
    unsigned char data[32]; // 0, length = 32 bytes
    unsigned int unkn32;    // not used??
    unsigned int unkn36;    // not used??
    unsigned int unkn40;    // byte 40  not used??
    unsigned int unkn44;    // not used?? 44
    unsigned char actData[32]; // actuator (6x4?) 48
    unsigned short modeTable[4];  // padInfo   80
    unsigned int frame;     // byte 88, u32 22
    unsigned int unkn92;    // not used ??
    unsigned int length;    // 96
    unsigned char modeOk;   // padInfo  100 Dunno about the name though...
    unsigned char modeCurId; // padInfo    101
    unsigned char unkn102;  // not used??
    unsigned char unknown;  // unknown
    unsigned char nrOfModes;   // padInfo   104
    unsigned char modeCurOffs; // padInfo   105
    unsigned char nrOfActuators;     // act  106
    unsigned char unkn107[5];  // not used??
    unsigned char state;    // byte 112
    unsigned char reqState; // byte 113
    unsigned char ok;       // padInfo  114
    unsigned char unkn115[13];  // not used??
};

/* end of pad.c */

/* end of padlib 1.2 */

struct pad_data *PadArea[2][2];
struct xpad_data *XPadArea[2][2];
struct padButtonStatus *PadStat[2] = { NULL, NULL };


void sifcall_pad1(struct t_sif_rpc_call* call, u32* bin, u32* bout) {
	int port;

	if (call->rpc_number != 1) {
#ifdef BIOS_LOG
		BIOS_LOG("pad1server unk call %x\n", call->rpc_number);
#endif
		return;
	}
#ifdef BIOS_LOG
	BIOS_LOG("pad1server cmd %x\n", bin[0]);
#endif
	switch (bin[0]) {
		case PAD_RPCCMD_OPEN:
			port = bin[1];

			bout[12/4] = 1;

			PadArea[port][0] = (struct pad_data*)PSM(*(unsigned long*)&bin[16/4]);
			PadArea[port][1] = (struct pad_data*)PSM(*(unsigned long*)&bin[16/4] + sizeof(struct pad_data));
			PadArea[port][1]->frame = 0;
			PadArea[port][0]->frame = 0;
			PadArea[port][0]->state = PAD_STATE_STABLE;
			PadArea[port][0]->reqState = PAD_RSTAT_COMPLETE;
			PadArea[port][0]->length = sizeof(struct padButtonStatus);
			PadStat[port] = (struct padButtonStatus*)PadArea[port][0]->data;
			PadStat[port]->btns[0] = 0xff;
			PadStat[port]->btns[1] = 0xff;
			break;

		case PAD_RPCCMD_SET_MMODE:
//			PadArea[bin[1]][bin[2]];
			bout[20/4] = 4;
			break;

		case PAD_RPCCMD_GET_PORTMAX:
			bout[12/4] = 2;
			break;

		case PAD_RPCCMD_GET_SLOTMAX:
			bout[12/4] = 1;
			break;
	}
}

void sifcall_pad2(struct t_sif_rpc_call* call, u32* bin, u32* bout) {
	if (call->rpc_number != 1) {
#ifdef BIOS_LOG
		BIOS_LOG("pad2server unk call %x\n", call->rpc_number);
#endif
		return;
	}
}
void sifcall_xpad1(struct t_sif_rpc_call* call, u32* bin, u32* bout)
{
	int port;

	if (call->rpc_number != 1) {
#ifdef BIOS_LOG
		BIOS_LOG("pad1server unk call %x\n", call->rpc_number);
#endif
		return;
	}
#ifdef BIOS_LOG
	BIOS_LOG("xpad1server cmd %x\n", bin[0]);
#endif
	switch (bin[0]) {
		case XPAD_RPCCMD_OPEN:
			port = bin[1];

			bout[12/4] = 1;

			XPadArea[port][0] = (struct xpad_data*)PSM(*(unsigned long*)&bin[16/4]);
			XPadArea[port][1] = (struct xpad_data*)PSM(*(unsigned long*)&bin[16/4] + sizeof(struct pad_data));
			XPadArea[port][1]->frame = 0;
			XPadArea[port][0]->frame = 0;
			XPadArea[port][0]->state = PAD_STATE_STABLE;
			XPadArea[port][0]->reqState = PAD_RSTAT_COMPLETE;
			XPadArea[port][0]->length = sizeof(struct padButtonStatus);
			PadStat[port] = (struct padButtonStatus*)XPadArea[port][0]->data;
			PadStat[port]->btns[0] = 0xff;
			PadStat[port]->btns[1] = 0xff;
			break;

		case XPAD_RPCCMD_SET_MMODE:
//			PadArea[bin[1]][bin[2]];
			bout[20/4] = 4;
			break;

		case XPAD_RPCCMD_GET_PORTMAX:
			bout[12/4] = 2;
			break;

		case XPAD_RPCCMD_GET_SLOTMAX:
			bout[12/4] = 1;
			break;

		case XPAD_RPCCMD_GET_MODVER:
			bout[12/4] = 0x300; // version??
//			Log=1;
			break;
	}
}

void sifcall_xpad2(struct t_sif_rpc_call* call, u32* bin, u32* bout) {
	if (call->rpc_number != 1) {
#ifdef BIOS_LOG
		BIOS_LOG("xpad2server unk call %x\n", call->rpc_number);
#endif
		return;
	}
}
