/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"


/* I must declare a function to avoid this kind of include */
#include "DmaC.h"

/* must create function to avoid this kind of declaration */
#include "IntrC.h"


/*
Execute an Handler at the adress specified by HandlerAdress
NOTA: __inline means compiler do not optimize the funstion
*/

extern char debugTempText[256];


_u8 BiosOpenFile( char * fFileName ) {

	_u8 	Result;
	long BiosFileSize;

	
	BiosFile = fopen( fFileName, "rb" );
	if( BiosFile != NULL )  {
		BiosFileSize = FileSizeOf( BiosFile ) ;
#ifdef EMU_LOG
		EMU_LOG("[BIOS]Open : %s ( size : %5.3f Ko)",fFileName , ( (float) BiosFileSize  / 1024));
#endif
		Result = TRUE; 
	}
	else	{
#ifdef EMU_LOG
		EMU_LOG("[BIOS]Error opening :%s: %s", fFileName ,strerror( errno ));
#endif
		Result = FALSE;
	}
	
	return Result;	
}



void CopyBiosToMemory ( void  ) {

		_u64 Addr;
		char c;

				
		Addr = 0;
		
		fseek( BiosFile, 0, SEEK_SET );
		while ( fread( &c , sizeof( char ), sizeof( char ), BiosFile ) != 0 ) {  
			BiosMemory[Addr] = c;
			Addr++;
		}

#ifdef EMU_LOG
		EMU_LOG("[BIOS]Copy BIOS To Memory:...Done");
#endif


}

void BiosCloseFile( void ) {
	
#ifdef EMU_LOG
		EMU_LOG("[BIOS]Close Bios File");
#endif
			
		if ( BiosFile != NULL ) fclose( BiosFile ); 
}






