/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/



//SYSCALL TABLE FROM ROMAN
//[module]	KERNEL
//[made by]	[RO]man & others (october 2002)
static void (*syscall_fct[256])(void) = 
{ 
// 0x00
	SYSCALL_RFU000_FullReset,		SYSCALL_ResetEE,				SYSCALL_SetGsCrt,				SYSCALL_RFU003, 
	SYSCALL_Exit, 					SYSCALL_RFU005, 				SYSCALL_LoadPS2Exe, 			SYSCALL_ExecPS2, 
	SYSCALL_RFU008, 				SYSCALL_RFU009, 				SYSCALL_AddSbusIntcHandler,		SYSCALL_RemoveSbusIntcHandler, 
	SYSCALL_Interrupt2Iop, 			SYSCALL_SetVTLBRefillHandler,	SYSCALL_SetVCommonHandler, 		SYSCALL_SetVInterruptHandler,
// 0x10
	SYSCALL_AddIntcHandler,				SYSCALL_RemoveIntcHandler, 		SYSCALL_AddDmacHandler, 		SYSCALL_RemoveDmacHandler, 
	SYSCALL__EnableIntc, 				SYSCALL__DisableIntc, 			SYSCALL__EnableDmac, 			SYSCALL__DisableDmac, 
	SYSCALL__SetAlarm, 					SYSCALL__ReleaseAlarm, 			SYSCALL__EnableIntc, 			SYSCALL__DisableIntc, 
	SYSCALL__iEnableDmac, 				SYSCALL__iDisableDmac, 			SYSCALL__iSetAlarm, 			SYSCALL__iReleaseAlarm, 
// 0x20
	SYSCALL_CreateThread, 				SYSCALL_DeleteThread, 			SYSCALL_StartThread, 			SYSCALL_ExitThread,
	SYSCALL_ExitDeleteThread, 			SYSCALL_TerminateThread, 		SYSCALL_iTerminateThread, 		SYSCALL_DisableDispatchThread,
	SYSCALL_EnableDispatchThread, 		SYSCALL_ChangeThreadPriority, 	SYSCALL_iChangeThreadPriority, 	SYSCALL_RotateThreadReadyQueue,
	SYSCALL_iRotateThreadReadyQueue, 	SYSCALL_ReleaseWaitThread, 		SYSCALL_iReleaseWaitThread, 	SYSCALL_GetThreadId, 
// 0x30
	SYSCALL_ReferThreadStatus, 			SYSCALL_iReferThreadStatus, 	SYSCALL_SleepThread, 			SYSCALL_WakeupThread,
	SYSCALL_iWakeupThread, 				SYSCALL_CancelWakeupThread, 	SYSCALL_iCancelWakeupThread, 	SYSCALL_SuspendThread,
	SYSCALL_iSuspendThread, 			SYSCALL_ResumeThread, 			SYSCALL_iResumeThread, 			SYSCALL_JoinThread,
	SYSCALL_RFU060, 					SYSCALL_RFU061, 				SYSCALL_EndOfHeap, 				SYSCALL_RFU063, 
// 0x40
	SYSCALL_CreateSema, 				SYSCALL_DeleteSema, 			SYSCALL_SignalSema, 			SYSCALL_iSignalSema,
	SYSCALL_WaitSema, 					SYSCALL_PollSema, 				SYSCALL_iPollSema, 				SYSCALL_ReferSemaStatus,
	SYSCALL_iReferSemaStatus, 			SYSCALL_RFU073, 				SYSCALL_SetOsdConfigParam, 		SYSCALL_GetOsdConfigParam, 
	SYSCALL_GetGsHParam, 				SYSCALL_GetGsVParam, 			SYSCALL_SetGsHParam, 			SYSCALL_SetGsVParam, 
// 0x50
	SYSCALL_RFU080_CreateEventFlag, 	SYSCALL_RFU081_DeleteEventFlag, 		SYSCALL_RFU082_SetEventFlag, 	SYSCALL_RFU083_iSetEventFlag,
	SYSCALL_RFU084_ClearEventFlag, 		SYSCALL_RFU085_iClearEventFlag, 		SYSCALL_RFU086_WaitEvnetFlag, 	SYSCALL_RFU087_PollEvnetFlag, 
	SYSCALL_RFU088_iPollEvnetFlag, 		SYSCALL_RFU089_ReferEventFlagStatus, 	SYSCALL_RFU090_iReferEventFlagStatus, SYSCALL_RFU091, 
	SYSCALL_EnableIntcHandler, 			SYSCALL_DisableIntcHandler, 			SYSCALL_EnableDmacHandler, 		SYSCALL_DisableDmacHandler, 
// 0x60
	SYSCALL_KSeg0, 						SYSCALL_EnableCache, 					SYSCALL_DisableCache, 			SYSCALL_GetCop0,
	SYSCALL_FlushCache, 				SYSCALL_RFU101_105, 					SYSCALL_CpuConfig, 				SYSCALL_iGetCop0, 
	SYSCALL_iFlushCache, 				SYSCALL_RFU101_105, 					SYSCALL_iCpuConfig, 			SYSCALL_sceSifStopDma, 
	SYSCALL_SetCPUTimerHandler, 		SYSCALL_SetCPUTimer, 					SYSCALL_SetOsdConfigParam2, 	SYSCALL_SetOsdConfigParam2,	 
// 0x70
	SYSCALL_GsGetIMR, 					SYSCALL_GsPutIMR, 						SYSCALL_SetPgifHandler, 		SYSCALL_SetVSyncFlag,
	SYSCALL_RFU116, 					SYSCALL_print, 							SYSCALL_sceSifDmaStat, 			SYSCALL_sceSifSetDma,
	SYSCALL_sceSifSetDChain, 			SYSCALL_sceSifSetReg, 					SYSCALL_sceSifGetReg, 			SYSCALL_ExecOSD,
	SYSCALL_Deci2Call, 					SYSCALL_PSMode, 						SYSCALL_MachineType, 			SYSCALL_GetMemorySize,

	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI ,
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 	
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI 	

	
};

static char * debug_syscall[256] =
{ 
// 0x00
	"SYSCALL_RFU000_FullReset",			"SYSCALL_ResetEE",					"SYSCALL_SetGsCrt",				"SYSCALL_RFU003", 
	"SYSCALL_Exit", 					"SYSCALL_RFU005", 					"SYSCALL_LoadPS2Exe", 			"SYSCALL_ExecPS2", 
	"SYSCALL_RFU008", 					"SYSCALL_RFU009", 					"SYSCALL_AddSbusIntcHandler",	"SYSCALL_RemoveSbusIntcHandler", 
	"SYSCALL_Interrupt2Iop", 			"SYSCALL_SetVTLBRefillHandler",		"SYSCALL_SetVCommonHandler", 	"SYSCALL_SetVInterruptHandler",
// 0x10
	"SYSCALL_AddIntcHandler",			"SYSCALL_RemoveIntcHandler", 		"SYSCALL_AddDmacHandler", 		"SYSCALL_RemoveDmacHandler", 
	"SYSCALL__EnableIntc", 				"SYSCALL__DisableIntc", 			"SYSCALL__EnableDmac", 			"SYSCALL__DisableDmac", 
	"SYSCALL__SetAlarm", 				"SYSCALL__ReleaseAlarm", 			"SYSCALL__EnableIntc", 			"SYSCALL__DisableIntc", 
	"SYSCALL__iEnableDmac", 			"SYSCALL__iDisableDmac", 			"SYSCALL__iSetAlarm", 			"SYSCALL__iReleaseAlarm", 
// 0x20
	"SYSCALL_CreateThread", 			"SYSCALL_DeleteThread", 			"SYSCALL_StartThread", 				"SYSCALL_ExitThread",
	"SYSCALL_ExitDeleteThread", 		"SYSCALL_TerminateThread", 			"SYSCALL_iTerminateThread", 		"SYSCALL_DisableDispatchThread",
	"SYSCALL_EnableDispatchThread", 	"SYSCALL_ChangeThreadPriority", 	"SYSCALL_iChangeThreadPriority", 	"SYSCALL_RotateThreadReadyQueue",
	"SYSCALL_iRotateThreadReadyQueue", 	"SYSCALL_ReleaseWaitThread", 		"SYSCALL_iReleaseWaitThread", 		"SYSCALL_GetThreadId", 
// 0x30
	"SYSCALL_ReferThreadStatus", 		"SYSCALL_iReferThreadStatus", 		"SYSCALL_SleepThread", 			"SYSCALL_WakeupThread",
	"SYSCALL_iWakeupThread", 			"SYSCALL_CancelWakeupThread", 		"SYSCALL_iCancelWakeupThread", 	"SYSCALL_SuspendThread",
	"SYSCALL_iSuspendThread", 			"SYSCALL_ResumeThread", 			"SYSCALL_iResumeThread", 		"SYSCALL_JoinThread",
	"SYSCALL_RFU060", 					"SYSCALL_RFU061", 					"SYSCALL_EndOfHeap", 			"SYSCALL_RFU063", 
// 0x40
	"SYSCALL_CreateSema", 				"SYSCALL_DeleteSema", 				"SYSCALL_SignalSema", 			"SYSCALL_iSignalSema",
	"SYSCALL_WaitSema", 				"SYSCALL_PollSema", 				"SYSCALL_iPollSema", 			"SYSCALL_ReferSemaStatus",
	"SYSCALL_iReferSemaStatus", 		"SYSCALL_RFU073", 					"SYSCALL_SetOsdConfigParam", 	"SYSCALL_GetOsdConfigParam", 
	"SYSCALL_GetGsHParam", 				"SYSCALL_GetGsVParam", 				"SYSCALL_SetGsHParam", 			"SYSCALL_SetGsVParam" ,
// 0x50
	"SYSCALL_RFU080_CreateEventFlag", 	"SYSCALL_RFU081_DeleteEventFlag", 		"SYSCALL_RFU082_SetEventFlag", 	"SYSCALL_RFU083_iSetEventFlag",
	"SYSCALL_RFU084_ClearEventFlag", 	"SYSCALL_RFU085_iClearEventFlag", 		"SYSCALL_RFU086_WaitEvnetFlag", "SYSCALL_RFU087_PollEvnetFlag", 
	"SYSCALL_RFU088_iPollEvnetFlag", 	"SYSCALL_RFU089_ReferEventFlagStatus", 	"SYSCALL_RFU089_iReferEventFlagStatus", 					"SYSCALL_RFU091", 
	"SYSCALL_EnableIntcHandler", 		"SYSCALL_DisableIntcHandler", 			"SYSCALL_EnableDmacHandler", 	"SYSCALL_DisableDmacHandler", 
// 0x60
	"SYSCALL_KSeg0", 					"SYSCALL_EnableCache", 					"SYSCALL_DisableCache", 		"SYSCALL_GetCop0",
	"SYSCALL_FlushCache", 				"SYSCALL_RFU101_105", 					"SYSCALL_CpuConfig", 			"SYSCALL_iGetCop0", 
	"SYSCALL_iFlushCache", 				"SYSCALL_RFU101_105", 					"SYSCALL_iCpuConfig", 			"SYSCALL_sceSifStopDma", 
	"SYSCALL_SetCPUTimerHandler", 		"SYSCALL_SetCPUTimer", 					"SYSCALL_SetOsdConfigParam2", 	"SYSCALL_SetOsdConfigParam2",	 
// 0x70
	"SYSCALL_GsGetIMR", 				"SYSCALL_GsPutIMR", 					"SYSCALL_SetPgifHandler", 		"SYSCALL_SetVSyncFlag",
	"SYSCALL_RFU116", 					"SYSCALL_print", 						"SYSCALL_sceSifDmaStat", 		"SYSCALL_sceSifSetDma",
	"SYSCALL_sceSifSetDChain", 			"SYSCALL_sceSifSetReg", 				"SYSCALL_sceSifGetReg", 		"SYSCALL_ExecOSD",
	"SYSCALL_Deci2Call", 				"SYSCALL_PSMode", 						"SYSCALL_MachineType", 			"SYSCALL_GetMemorySize",

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,
	

	
};


