/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>




#include "nSX2.h"
#include "PS2Edefs.h"

#include"_Debuger/debuger.h"

#include "main.h"

#include "Sif.h"
#include "pluggins_main.h"


#define LoadSIFsym1(dest, name) \
	LoadSym(SIF##dest, _SIF##dest, name, 1);

#define LoadSIFsym0(dest, name) \
	LoadSym(SIF##dest, _SIF##dest, name, 0); \
	if (SIF##dest == NULL) SIF##dest = (_SIF##dest) SIF_##dest;






void *SIFplugin = NULL;

_u8 LoadSifPluggin( char * filename ) {

	int result;
	void *drv;
	
    if (SIFplugin != NULL) { FreeLibrary((HMODULE)SIFplugin); }  // * Free plugin
    
 	SIFplugin = LoadLibrary(filename);
	if (SIFplugin == NULL) { ShowMessage ("Could Not Load SIF Plugin %s\n", filename); return -1; }
	drv = SIFplugin;

	sprintf(SifPluginToUse,filename);

	LoadSIFsym1(DllAbout,           "DllAbout");
	LoadSIFsym1(Initialize,         "Initialize");
	LoadSIFsym1(DllTest,            "DllTest");
	LoadSIFsym1(BindModule,         "BindModule");
	LoadSIFsym1(SetRPCVersion,      "SetRPCVersion");
	LoadSIFsym1(GetDllInfo,         "GetDllInfo");
	LoadSIFsym1(CloseDLL,           "CloseDLL");
	LoadSIFsym1(DllConfig,          "DllConfig");
	LoadSIFsym1(Run_DVD,            "Run_DVD");     
	LoadSIFsym1(GetElfAdd,			"GetElfAdd");


	return ( 0 );
}

/*******************************************************************/



extern SModuleBind nsx2SIFBindModule[SIF_PLUGGIN_MAX_BIND];
SSifInitialize	nsx2SifInitialize;

void* SifPluginGetMemoryPointer (DWORD _dwAddress) { 	return (&MipsMemory[_dwAddress & 0x01FFFFFF ]) ;}
void SifPluginSignalSema(int _dwSemaId) { 	
	int SemaID;
	if ( _dwSemaId < 0 ) SemaID = 0;
	else SemaID = _dwSemaId ;

	Ps2Bios.Sema[ SemaID ].sema->currentCount++; 

/*	
	if ( Ps2Bios.Sema[ SemaID ].sema->currentCount > Ps2Bios.Sema[ SemaID ].sema->maxCount ) 
		Ps2Bios.Sema[ SemaID ].sema->currentCount = Ps2Bios.Sema[ SemaID ].sema->maxCount;
*/
}
void SifPluginLog(char* _pMessage) { 	
	char tempText[1024];
	sprintf(tempText,"[SifPlugin]:%s",_pMessage);

#ifdef EMU_LOG
	EMU_LOG(tempText);
#endif



}



_u8 BindSifPluggin( void  ) {
	
	_u8 nbErrors = 0;
    _u8   my_result ; 
	_u16	boucle;

	nsx2SifInitialize.pGetMemoryPointer = SifPluginGetMemoryPointer;
	nsx2SifInitialize.pSignalSema = SifPluginSignalSema;
	nsx2SifInitialize.pLog = SifPluginLog;


	(*SIFInitialize)(nsx2SifInitialize );
	
 	for (boucle=0; boucle<SIF_PLUGGIN_MAX_BIND; boucle++)
 	{
  		nsx2SIFBindModule[boucle].dwBindNumber = 0;
  		nsx2SIFBindModule[boucle].pCallFunction = NULL;
 	}  

	nsx2SIFBindModule[BIND_RPC_NPM_USER].dwBindNumber = (_u32)RPC_NPM_USER ;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_RPC_NPM_USER]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_CDVD_IRX].dwBindNumber = (_u32)CDVD_IRX;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_CDVD_IRX]);
	if ( my_result == FALSE ) nbErrors++;

	nsx2SIFBindModule[BIND_SJPCM_IRX].dwBindNumber = (_u32)SJPCM_IRX;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_SJPCM_IRX]);
	if ( my_result == FALSE ) nbErrors++;	



	nsx2SIFBindModule[BIND_AMIGAMOD_IRX].dwBindNumber = (_u32)AMIGAMOD_IRX;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_AMIGAMOD_IRX]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000001].dwBindNumber = (_u32)0x80000001;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000001]);
	if ( my_result == FALSE ) nbErrors++;



	nsx2SIFBindModule[BIND_0x80000003].dwBindNumber = (_u32)0x80000003;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000003]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x80000400].dwBindNumber = (_u32)0x80000400;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000400]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000592].dwBindNumber = (_u32)0x80000592;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000592]);
	if ( my_result == FALSE ) nbErrors++;



	nsx2SIFBindModule[BIND_0x80000593].dwBindNumber = (_u32)0x80000593;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000593]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000595].dwBindNumber = (_u32)0x80000595;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000595]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x80000596].dwBindNumber = (_u32)0x80000596;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000596]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000597].dwBindNumber = (_u32)0x80000597;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000597]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x8000059a].dwBindNumber = (_u32)0x8000059a;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x8000059a]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000601].dwBindNumber = (_u32)0x80000601;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000601]);
	if ( my_result == FALSE ) nbErrors++;



	nsx2SIFBindModule[BIND_0x8000010f].dwBindNumber = (_u32)0x8000010f;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x8000010f]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x8000011f].dwBindNumber = (_u32)0x8000011f;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x8000011f]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x80000100].dwBindNumber = (_u32)0x80000100;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000100]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000101].dwBindNumber = (_u32)0x80000101;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000101]);
	if ( my_result == FALSE ) nbErrors++;

	nsx2SIFBindModule[BIND_0x80000006].dwBindNumber = (_u32)0x80000006;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000006]);
	if ( my_result == FALSE ) nbErrors++;

	return ( nbErrors );
}




