/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>




#include "nSX2.h"
#include "PS2Edefs.h"

#include"_Debuger/debuger.h"

#include "main.h"

#include "Sif.h"
#include "pluggins_main.h"

char 	ElfToExecute[FILE_NAME_LENGHT];		//Elf File to Execute
char 	GSPluginToUse[FILE_NAME_LENGHT];
char 	InputPluginToUse[FILE_NAME_LENGHT];
char 	SifPluginToUse[FILE_NAME_LENGHT];
char 	DBGPluginToUse[FILE_NAME_LENGHT];


u32  (* PS2EgetLibTypeGS)();
u32  (* PS2EgetLibVersionGS)();
char*(* PS2EgetLibNameGS)();

u32  (* PS2EgetLibTypePAD)();
u32  (* PS2EgetLibVersionPAD)();
char*(* PS2EgetLibNamePAD)();


void *SysLoadSym(void *lib, char *sym) 
{
	void *tmp = GetProcAddress((HINSTANCE)lib, sym);
	return tmp;
}


/*************************************************************************************/

/* 	I need this variable, because in case of the user close the emu without running 
	a demo, the emulator crash at exit.

*/

_u8	PluginsAreOpened =  FALSE;


HWND myHwnd;


int PLUGINS_InitAll() {
	int result;


	if ( PluginsAreOpened == TRUE ) 	PLUGINS_ShutdownAll(); 

    result = (*GSinit)();

	if ( result != 0 ) {
#ifdef EMU_LOG
		EMU_LOG("[GS Plugin] FATAL ERROR while graphics initialisation...Sorry Exiting");
		return FALSE;

#endif
	} else {
#ifdef EMU_LOG
		EMU_LOG("[GS Plugin] Init OK");
#endif
	
	}

	/* GS : Open Display */			
	result = (*GSopen)(&myHwnd ,"Video Output" );
	if ( result != 0 ) {
#ifdef EMU_LOG
		EMU_LOG("[GS Plugin] FATAL ERROR while graphics opening...Sorry Exiting");
#endif
		return FALSE;

	} else {
#ifdef EMU_LOG
		EMU_LOG("[GS Plugin] Open OK");
#endif
	}


	result = (*PAD1init)(1);


	/* PAD :  */	
	result = (*PAD1open)(&myHwnd);
	if ( result != 0 ) {
#ifdef EMU_LOG
		EMU_LOG("[Input Plugin] FATAL ERROR while Input initialisation...Sorry Exiting");
#endif	

		return FALSE;
	
	} else {
#ifdef EMU_LOG
		EMU_LOG("[Input Plugin] OK");
#endif		
	}

	PluginsAreOpened =  TRUE;

	return TRUE;
}

void PLUGINS_ShutdownAll() {

	if ( PluginsAreOpened == TRUE ) {

		(*GSclose)();
    	(*GSshutdown)();

   		(*PAD1close)();
    	(*PAD1shutdown)();
			
		PluginsAreOpened = FALSE;
	
	}


}






