/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"
 
#include "r5900_main.h"

#include "r5900_debug_regs.h"

#include "r5900_core.h"	//for NI

#include "r5900_cop0.h"
#include "r5900_cop0_table.h"

#include "PS2Edefs.h"
 
/*****************************************************************************************************************
									COP0 INSTRUCTION SET
*****************************************************************************************************************/

void    COP0()	{	cop0_opc[(_OPCODE_ & 0x3E00000)>>21]();}

void	C0() 	{	cop0c0_opc[(_OPCODE_ & 0x3F)](); }

void 	BC0()	{	cop0c0_bc0_opc[((_OPCODE_ >> 21 ) & 0x3)]();}




void 	BC0F()		{	


	INCREMENT_PC();
}

void 	BC0T()		{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

void 	BC0FL()		{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

void 	BC0TL()		{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void    CACHE() 	{
/*
	switch( CURRENT_RT & 0x3 ) {
		// Primary Instruction
		case 0: {
			switch ( (CURRENT_RT >> 2 ) & 0x7 ) {

				case 0x4:	MipsCpu.CPR0[28][0] =  ( MipsCpu.CPR0[28][0] & 0xFFFF )  |   (_u32)0x1000 ; 
					break;	//NI

				//case 0x5:	
			}

		}
		break;


		//default:

	}
*/
	
	MipsCpu.GPR[CURRENT_BASE].lo = 0x1000 ;

    
    INCREMENT_PC();
}



void   	MF0() 	{
	MipsCpu.GPR[CURRENT_RT].lo = MipsCpu.CPR0[CURRENT_RD][0];

	INCREMENT_PC();
}




void   	MT0() 	{
	MipsCpu.CPR0[CURRENT_RD][0] = (_u32)MipsCpu.GPR[CURRENT_RT].lo;

	INCREMENT_PC();
}

void	TLBP() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

void	TLBR() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

void	TLBWI() {	

	INCREMENT_PC();
}


void	TLBWR() {	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

void	ERET() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void 	EI() 	{

	MipsCpu.CPR0[12][0]	=	MipsCpu.CPR0[12][0]  | 0x00010000;
	IntC.IntrEnable = TRUE;
	if ( debug_systemcall == 1 )	PrintToBIOSOutput (  "Interrupts Enabled\n" );

	INCREMENT_PC();
}


void 	DI() 	{

	MipsCpu.CPR0[12][0]	=	MipsCpu.CPR0[12][0]  & 0xFFFEFFFF;
	IntC.IntrEnable = FALSE;
	if ( debug_systemcall == 1 ) PrintToBIOSOutput (  "Interrupts Diasbled\n" );
	INCREMENT_PC();
}


